lorom

;--- Advanced Arm Cannon Palette - OPTIONS ---

;Advanced arm cannon palette changes samus's arm cannon palette depending on beam combination.
;In addition this patch also adds a beam glow effect on samus when shooting a beam projectile while charge beam is equipped.
;OPTIONS has the same changes as BASIC and also adds the possibility to change the arm cannon (and beam palettes) with palette presets.
;It adds 2 new options in the special settings:
;- "Cannon Color Setting": moves you to a seperate menu where you can change the cannon color with presets.
;- "Apply Color To Beam": applies an unique beam palette to all beam variations based on the cannon palette.


;---------------------------------------Defines-----------------------------------------------------
;$09EC / $09EE: unused, get saved in sram (important)
;Range of unused ram space that get saved into sram: $09EC - $0A03
!CannonPalette = $09EC
!ApplyColorToBeams = $09EE


;IMPORTANT DEFINES! DO NOT CHANGE!
!DPSourcePalette = $20
!DPSourcePaletteBank = $22
!DPSourcePositiveFading = $24
!DPSourceNegativeFading = $26

!ActionIndex = $0ACE		;used for various actions (speed boosting, shine sparking, etc.)
!ChargeIndex = $0B62		;used for charge glow when ready to fire up a fully charged shot
!DeathSequenceIndex = $0DE4 ;death palette index (0,2-8 ; 1 is flashing white)
!HeatGlowIndex = $1EEF		;used when FX flags 0 and 1 in norfair are set

!Numerator = $C400			;position of color transition
!Denumerator = $C402		;range of presicion for color transition (everywhere set to $10)
!ColorIndex = $C404			;cycle index for arm cannon palette change


;---------------------------------------Freespace---------------------------------------------------
;Can be changed to any bank with freespace
!BankOptionFreeSpace = $85D000	;cannon color options menu			(size: $4FB)
!BankFreeSpace = $85D800		;main code for arm cannon palette	(size: $672)
!BankTransitionTable = $85E000	;transition table					(size: $1F3E)
!BankBeamPalettes = $90F800		;beam palettes						(size: $5E0)
!BankCannonPalette = $9BD000	;arm cannon palettes				(size: $198)


;---------------------------------------ArmCannonColor----------------------------------------------
;How many colors should be changed in samus palette set (range: $01-$04; default: $04)
!PaletteChangeAmount = $0004

;Which color of samus palette set should be changed (depends on !PaletteChangeAmount)
;(range: $00-$0F; $00 is the transparent palette and should be set for the other target palettes if unused)
!TargetPalette0 = $0D
!TargetPalette1 = $05
!TargetPalette2 = $08
!TargetPalette3 = $07

;Set arm cannon palette option when starting new game
;(range: $00-$34; default: $01)
;(Metroid: $00-$0A) ($01 = MF beam color; $06 = PB beam color)
;(Gems: $0B-$1A)
;(Metal: $1B-$24)
;(Mixed: $25-$30)
;(Miscellaneous: $31-$34)
!ArmCannonPaletteStartingOption = $01


;---------------------------------------ColorChangeMethode------------------------------------------
;Here you can change the routine how the colors should be changed.
;	Transitional:	change color to a faded point between source and target
;	Fading:			have a fixed value added or subracted to a color

!Charge = Transitional
;Charge also used in death sequence
!HeatGlow = Fading
!SpeedBooster = Fading
;SpeedBooster also used when loading from save station
!Shine = Transitional
!ShineSpark = Fading
;ShineSpark also used in pseudo screw attack
!ScrewAttack = Fading

;Further information in "Target Colors / Index" at line 957.


;---------------------------------------BeamGlow----------------------------------------------------
;When charge beam is equipped, samus emits a glow when firing a beam shot.
;Here you can adjust, rather it's a fixed or fading glow, the duration and the intensity of the fixed glow.

;Beam glow uses the already loaded beam palette set as reference.
;Change target color of beam palette for samus beam glow (range: $00-$0F; default: $02)
!BeamGlowTargetColor = $02


;--- Normal Beam Shots ---

;Duration of beam glow from normal shots. If "fixed" bit is not set, the timer will be used as intensity gradiant:
;$00 skips beam glow entirely. $00-$08: strength of starting glow.
;If the duration is set beyond $08, samus will be covered with just the target color until the timer reaches $08.
;After that, the beam glow fading effect comes into play. (range: $00-$FF; default: $04)
!BeamGlowDurationNormal = $04

;Change beam glow type of normal shots, rather or not it should be fixed or have a fading effect.
;(Warning! Normal beam shots can be spammed. Using "fading" for normal shots can cause lag to some extend.
;(Setting this bit to "fixed" is advised.) (range: $00["fading"]/$01["fixed"]; default: $01)
!BeamGlowFixedBitNormal = $01

;Adjust the intensity of the fixed beam glow from normal shots. If "fixed" bit is not set, this does nothing.
;(range: $00-$10; default: $0A) ($00 skips glow entirely; $10 and above covers samus with just the target color)
!BeamGlowFixedTransitionNormal = $0A


;--- Charged Beam Shots ---

;Duration of beam glow from charged shots. If "fixed" bit is not set, the timer will be used as intensity gradiant:
;$00 skips beam glow entirely. $00-$08: strength of starting glow.
;If the duration is set beyond $08, samus will be covered with just the target color until the timer reaches $08.
;After that, the beam glow fading effect comes into play. (range: $00-$FF; default: $0C)
!BeamGlowDurationCharged = $0C

;Change beam glow type of charged shots, rather or not it should be fixed or have a fading effect.
;(range: $00["fading"]/$01["fixed"]; default: $00)
!BeamGlowFixedBitCharged = $00

;Adjust the intensity of the fixed beam glow from charged shots. If "fixed" bit is not set, this does nothing.
;(range: $00-$10; default: $00) ($00 skips glow entirely; $10 and above covers samus with just the target color)
!BeamGlowFixedTransitionCharged = $00



;---------------------------------------------------------------------------------------------------
;|x|									BANK $82 / $??	Option menu								 |x|
;---------------------------------------------------------------------------------------------------
{ ;---bank $82 doesn't need available freespace, but the newly added option menu does---
;---------------------------------------BANK $81 / $8E----------------------------------------------
ORG $818DF7 : DW $5C00						;put "beta minimap tiles" into vram, too
ORG $8ED600 : INCBIN CannonColorTiles.bin	;add graphics for cannon color option menu

ORG $818E54 : DW $E800						;read "beta minimap tiles" somewhere else
ORG $8EE800 : INCBIN BetaMinimapTiles.bin	;add beta minimap tiles here

ORG $81B2D6		;new game
	STZ $09C8 : STZ $09C6	;missiles
	STZ $09CC : STZ $09CA	;super missiles
	STZ $09D0 : STZ $09CE	;power bombs
	LDA.w #!ArmCannonPaletteStartingOption*2 : STA !CannonPalette		;cannon color to "beam color"
	STZ !ApplyColorToBeams	;apply color to beams -> off

ORG $8EE470		;use pal 3 of options menu as cannon color display
	DW $19FF, $1D55, $10AD, $53FF
	DW $1104, $21A8, $3A4E, $4AD2


;---------------------------------------BANK $82----------------------------------------------------
ORG $82EBAA : JSR (OptionIndex,x)			;use different pointer table for menu index

ORG $82EBC1		;was option index table, now used for new checkbox
CheckBoxPosition:
	DW $02B2, $02B4, $02F2, $02F4
CheckBoxActive:
	DW $02B8, $02B9, $02BA, $02BB
CheckBoxDeactive:
	DW $06B4, $06B5, $06B6, $06B7
;2 bytes left

ORG $82EC88
;special settings (english, changed)
	LDA #$9700 : STA $48					;save bank
	LDA.w #SpecialSettingImage : STA $47	;save source of compressed data
	JSL $80B0FF								;decompression routine
	DL $7FD000								;target to uncompress to
;cannon color setting
	LDA #$9700 : STA $48
	LDA.w #CannonColorSettingImage : STA $47
	JSL $80B0FF
	DL $7FD800
	BRA ContinueOptionMenuDecompression

MoveToCannonColorSetting:					;use deleted code for small routine
	LDA #$0002 : STA $099E
	JMP $EE55
PADBYTE $FF : PAD $82ECBB	;delete remaining code
ContinueOptionMenuDecompression:


;Dissolve out screen
;$099E is option menu index
; 0 = goto option menu
; 1 = (unused)
; 2 = goto cannon color settings
; 3 = goto controller settings
; 4 = goto special settings
ORG $82EF43
	LDY #$37FF						;set target for block move instruction
	LDA $099E : BEQ .loadOption
	CMP #$0004 : BEQ .loadSpecial
	CMP #$0002 : BEQ .loadCannon

;load controller settings image		;(decompressed, located in $7FC800)
	LDA #$07FF : LDX #$CFFF : PHB	;setup block move instruction
	MVP $7F7E : PLB					;transfer decompressed image to visible location
	LDY #$F4CA : JSR $8BCB	;load options menu objects / instruction
	JSR $F4DC				;load controller options from controller bindings
	JMP $F587				;setting up icons from controller bindings

;load cannon color setting image	;(decompressed, located in $7FD800)
.loadCannon
	LDA #$07FF : LDX #$DFFF : PHB
	MVP $7F7E : PLB
	JSL SetCannonGroupIndex				;set "group","color" text and palette
	LDY #$F4BE : JMP $8BCB				;load options menu objects / instruction

;load special settings image		;(decompressed, located in $7FD000)
.loadSpecial
	LDA #$07FF : LDX #$D7FF : PHB
	MVP $7F7E : PLB
	JSR ApplyColorToBeamDraw							;draw what state "apply color to beam" is
	LDA #$0002 : STA $099E : JSR DrawIconCancelCheckbox	;draw what state "icon cancel" is
	INC $099E : JSR DrawMoonwalkCheckbox				;draw what state "moon walk" is
	INC $099E								;set cursor to 4
	LDY #$F4D0 : JMP $8BCB					;load options menu objects / instruction

;load options menu					;(decompressed, located in $7FC000)
.loadOption
	LDA #$07FF : LDX #$C7FF : PHB
	MVP $7F7E : PLB
	JSR $EDED					;gray out "english text"/"japanese text", depending on setting
	LDY #$F4C4 : JMP $8BCB		;load options menu objects / instruction
	

IconCancelSwitch:
	LDA $09EA : EOR #$0001 : STA $09EA
	JMP DrawCheckbox
MoonWalkSwitch:
	LDA $09E4 : EOR #$0001 : STA $09E4
	JMP DrawCheckbox
;8 bytes left


;dissolve in screen
ORG $82EFEC
	LDA $51 : CMP #$0F : BNE +
	STZ $57 : REP #$20 : STZ $0723 : STZ $0725
	LDA $099E : ASL : TAX
	LDA.w DissolveInIndex,x : STA $0DE2
	STZ $099E : RTS
+ : REP #$20 : RTS
DissolveInIndex:
	DW $0003, $0000, $000D, $0007, $0008
; 0: next move to option menu
; 1: never called
; 2: next move to cannon color setting
; 3: next move to controller settings
; 4: next move to special settings


;special setting menu routine, changed pointer for more space
SpecialSettingsMenu:
	LDA $8F : BIT #$0800 : BEQ +	;if pressed up
	LDA #$0037 : JSL $809049		;play cursor sound
	DEC $099E : BPL ++
	LDA #$0003 : STA $099E
	BRA ++

+ : BIT #$0400 : BEQ ++				;if pressed down
	LDA #$0037 : JSL $809049		;play cursor sound
	INC $099E : LDA $099E
	CMP #$0004 : BNE ++
	STZ $099E

++ : BIT #$8000 : BEQ ++			;if pressed B
	LDA #$0038 : JSL $809049		;play cursor select sound
	STZ $099E : JMP $EE55

++ : BIT #$1380 : BEQ ++			;if selected (A, Start, Left, Right)
	LDA #$0038 : JSL $809049		;play cursor select sound
	LDA $099E : ASL : TAX : JMP (SpecialSettingsOption,x)

++ : RTS

SpecialSettingsOption:
	DW MoveToCannonColorSetting, ApplyColorToBeamSwitch, IconCancelSwitch, MoonWalkSwitch

;gray / white out text for "icon cancel" and "moon walk"
DrawIconCancelCheckbox:
	LDA $09EA : BNE DrawOptionLeftActive : BRA DrawOptionRightActive
DrawMoonwalkCheckbox:
	LDA $09E4
DrawCheckbox:
	BNE DrawOptionLeftActive

DrawOptionRightActive:
	LDA #$000C : STA $00
	LDA #$0400 : STA $02
	TDC : STA $04
	BRA ContinueDrawOptionActive

DrawOptionLeftActive:
	LDA #$000C : STA $00
	TDC : STA $02
	LDA #$0400 : STA $04

ContinueDrawOptionActive:
	LDA $099E : DEC : DEC : ASL : ASL : TAY
	PHY : LDX SwitchDrawOffset,y
	LDY $00 : LDA $02 : JSR $ED28
	PLY : PHY : LDX SwitchDrawOffset+2,y
	LDY $00 : LDA $02 : JSR $ED28
	PLY : PHY : LDX SwitchDrawOffset+8,y
	LDY $00 : LDA $04 : JSR $ED28
	PLY : LDX SwitchDrawOffset+10,y
	LDY $00 : LDA $04 : JSR $ED28
	RTS


;offset for gray/white out settings for "icon cancel" and "moon walk"
SwitchDrawOffset:
	DW $03A0, $03E0, $04A0, $04E0
	DW $03AE, $03EE, $04AE, $04EE
	
ApplyColorToBeamSwitch:
	LDA !ApplyColorToBeams : EOR #$0001 : STA !ApplyColorToBeams

ApplyColorToBeamDraw:
	LDA !ApplyColorToBeams : BNE +
;deactive
	LDY #$0006
- : LDX CheckBoxPosition,y
	LDA CheckBoxDeactive,y : STA $7E3000,x
	DEY : DEY : BPL -
	RTS
;active
+ : LDY #$0006
- : LDX CheckBoxPosition,y
	LDA CheckBoxActive,y : STA $7E3000,x
	DEY : DEY : BPL -
	RTS


;Pointer for cursor position, depending on game option menu index
CursorPositionPointer:
	DW $0000, $0000, OptionMenuCursor, OptionMenuCursor
	DW $0000, $0000, $0000, ControllerSettingCursor
	DW SpecialSettingCursor, $0000, $0000, OptionMenuCursor
	DW $0000, CannonColorCursor


OptionIndex:
	DW $EBDB	; 0:
	DW $EC11	; 1: Loading options screen
	DW $ECE4	; 2: Fading in options screen
	DW $ED42	; 3: Options screen
	DW $EEB4	; 4: Start game
	DW $EF18	; 5: Dissolve out screen
	DW $EFDB	; 6: Dissolve in screen
	DW $F159	; 7: Controller settings
	DW SpecialSettingsMenu		; 8: Special settings
	DW $F271	; 9: Scroll controller settings down
	DW $F285	; Ah: Scroll controller settings up
	DW $EE6A	; Bh: Transition back to file selection
	DW $EE92	; Ch: Fading out options screen to start game
;new in list
	DW HijackCannonColorSettingMenu	; Dh: Cannon color setting
;3 bytes left


;cursor position
ORG $82F2C3 : LDA CursorPositionPointer,y

;2 words per option ([x position],[y position])
ORG $82F2ED
OptionMenuCursor:
	DW $0018, $0038, $0018, $0058
	DW $0018, $0070, $0018, $0090
	DW $0018, $00B0
ControllerSettingCursor:
	DW $0028, $0030, $0028, $0048
	DW $0028, $0060, $0028, $0078
	DW $0028, $0090, $0028, $00A8
	DW $0028, $00C0, $0028, $00B8
	DW $0028, $00D0
SpecialSettingCursor:
	DW $0010, $0040, $0010, $0058
	DW $0010, $0078, $0010, $0098
CannonColorCursor:
	DW $0038, $0040, $0038, $0068

HijackCannonColorSettingMenu:
	JSL CannonColorSettingMenu
	BCS + : RTS
+ : JMP $EE55


;title border
ORG $82F4BE : DW $F35B, $8C10, $F49E	;position of border setup / RTS / border instruction


;---------------------------------------BANK $??----------------------------------------------------
ORG !BankOptionFreeSpace
;cannon color menu routine
CannonColorSettingMenu:
	PHB : PHK : PLB
	LDA $8F : BIT #$0800 : BEQ +	;if pressed up
	LDA $099E : BEQ ++
	DEC $099E
	LDA #$0037 : JSL $809049		;play cursor sound
	BRA ++

+ : BIT #$0400 : BEQ ++				;if pressed down
	LDA $099E : BNE ++
	INC $099E
	LDA #$0037 : JSL $809049		;play cursor sound	

++ : BIT #$0200 : BNE .left				;if pressed left
	BIT #$0100 : BNE .right				;if pressed right
	BIT #$9080 : BNE .accept			;if pressed (A, B or Start)
	PLB : CLC : RTL
	
.left
	LDA #$0037 : JSL $809049		;play cursor sound
	LDA $099E : ASL : TAX
	JMP (CannonColorSettingLeft,x)

.right
	LDA #$0037 : JSL $809049		;play cursor sound
	LDA $099E : ASL : TAX
	JMP (CannonColorSettingRight,x)

.accept
	LDA #$0038 : JSL $809049			;play cursor select sound
	LDA #$0004 : STA $099E				;set cursor to 4 (go to special settings)
	PLB : SEC : RTL

CannonColorSettingLeft:
	DW CannonGroupLeft, CannonColorLeft
CannonColorSettingRight:
	DW CannonGroupRight, CannonColorRight



!_ = $00	;empty space

!A = $01	;letters
!B = $02
!C = $03
!D = $04
!E = $05
!F = $06
!G = $07
!H = $08
!I = $09
!J = $0A
!K = $0B
!L = $0C
!M = $0D
!N = $0E
!O = $0F
!P = $10
!Q = $11
!R = $12
!S = $13
!T = $14
!U = $15
!V = $16
!W = $17
!X = $18
!Y = $19
!Z = $1A

!End = $FF	;terminator


;group: set cannon color value to fix point
;$20 GroupIndex
SetCannonGroupIndex:
	PHB : PHK : PLB
	LDX #$0000
- : INX : INX
	LDA.w CannonGroupRange,x : CMP !CannonPalette : BCC - : BEQ - : STX $20
	BRA CannonGroupOptionText

CannonGroupLeft:
	LDX $20 : DEX : DEX : BNE +
	LDX #$000A
+ : STX $20 : DEX : DEX : LDA.w CannonGroupRange,x : STA !CannonPalette
	BRA CannonGroupOptionText

CannonGroupRight:
	LDX $20 : INX : INX : CPX #$000C : BCC +
	LDX #$0002
+ : STX $20 : DEX : DEX : LDA.w CannonGroupRange,x : STA !CannonPalette
	BRA CannonGroupOptionText

CannonColorLeft:
	LDX $20 : DEX : DEX
	LDA !CannonPalette : DEC : DEC : CMP.w CannonGroupRange,x : BMI +
	STA !CannonPalette : BRA CannonColorOptionPaletteAndText

+ : LDX $20 : LDA.w CannonGroupRange,x : DEC : DEC : STA !CannonPalette
	BRA CannonColorOptionPaletteAndText

CannonColorRight:
	LDX $20
	LDA !CannonPalette : INC : INC : CMP.w CannonGroupRange,x : BPL +
	STA !CannonPalette : BRA CannonColorOptionPaletteAndText
	
+ : DEX : DEX : LDA.w CannonGroupRange,x : STA !CannonPalette
	BRA CannonColorOptionPaletteAndText


CannonGroupOptionText:
	LDX $20 : LDY.w CannonGroupTextPointer,x		;set source for text drawing
	LDX #$31D8										;set target ($7E3000) for text drawing
	JSR ApplyUpperCannonColorText
	LDX $20 : LDY.w CannonGroupTextPointer,x
	LDX #$3218
	JSR ApplyLowerCannonColorText

CannonColorOptionPaletteAndText:
;load beam color and set to palette
	TDC : TAY
	LDX !CannonPalette : LDA.l BeamColorPalettePointer,x : BNE +	;load pointer to current selected beam palette
	LDA #Beam_M_Power_			;if pointer is zero (beam color active) set pointer to power beam palette
+ : CLC : ADC #$0004 : TAX		;beam palette offset for color transfer

- : LDA.l !BankBeamPalettes/$10000*$10000,x : PHX : TYX	;load beam color from bank
	STA $7EC070,x : PLX									;save color to palette $3:($8-$B)
	INX : INX : INY : INY : CPY #$0008 : BCC -

;load cannon color and set to palette
	LDX !CannonPalette : LDA.l PalettePointer,x
	SEC : SBC.w #!BankCannonPalette : TAX				;load pointer to current selected cannon palette and its offset for color transfer

- : LDA.l !BankCannonPalette,x : PHX : TYX				;load cannon color from bank
	STA $7EC070,x : PLX									;save color to palette $3:($C-$F)
	INX : INX : INY : INY : CPY #!PaletteChangeAmount*2+8 : BCC -

	LDX !CannonPalette : LDY.w CannonColorTextPointer,x
	LDX #$3318
	JSR ApplyUpperCannonColorText
	LDX !CannonPalette : LDY.w CannonColorTextPointer,x
	LDX #$3358
	JSR ApplyLowerCannonColorText
	PLB : CLC : RTL


;[X] = target offset
;[Y] = source offset
ApplyUpperCannonColorText:
	LDA #$000C : SEP #$20
;create "color" text upper row
- : PHA : LDA $0000,y : CMP #$FF : BEQ FillEmptyCannonColorText			;if $FF (End) go to "end" branch
	PHX : TAX : LDA.w CannonTextUpperIndex,x		;load letter of current position
	PLX : STA $7E0000,x								;save tile
	INX : INX : INY
	PLA : DEC : BPL - : BRA ReturnCannonColorText	;loop

ApplyLowerCannonColorText:
	LDA #$000C : SEP #$20
;create "color" text upper row
- : PHA : LDA $0000,y : CMP #$FF : BEQ FillEmptyCannonColorText			;if $FF (End) go to "end" branch
	PHX : TAX : LDA.w CannonTextLowerIndex,x		;load letter of current position
	PLX : STA $7E0000,x								;save tile
	INX : INX : INY
	PLA : DEC : BPL - : BRA ReturnCannonColorText	;loop

FillEmptyCannonColorText:
	PLA : TAY : LDA #$0F		;end: fill remaining space with empty tiles
- : STA $7E0000,x : INX : INX	;save tile
	DEY : BPL -					;loop
ReturnCannonColorText:
	REP #$20 : RTS


CannonGroupRange:
	DW $0000, $0016, $0036, $004A, $0062, $006A

CannonGroupTextPointer:
	DW $0000, Group_Metroid, Group_Gems, Group_Metal, Group_Painted, Group_Miscellaneous


CannonColorTextPointer:
	;group "Metroid"
	DW N_00, N_02, N_04, N_06
	DW N_08, N_0A, N_0C, N_0E
	DW N_10, N_12, N_14
	;group "Gems"
	DW G_16, G_18, G_1A, G_1C
	DW G_1E, G_20, G_22, G_24
	DW G_26, G_28, G_2A, G_2C
	DW G_2E, G_30, G_32, G_34
	;group "Metal"
	DW M_36, M_38, M_3A, M_3C
	DW M_3E, M_40, M_42, M_44
	DW M_46, M_48
	;group "Mixed"
	DW X_4A, X_4C, X_4E, X_50
	DW X_52, X_54, X_56, X_58
	DW X_5A, X_5C, X_5E, X_60
	;group "Miscellaneous"
	DW A_62, A_64, A_66, A_68

;index for upper side of letters
CannonTextUpperIndex:
	DB $0F, $0A, $0B, $0C, $0D, $0E, $0E, $0C
	DB $21, $22, $23, $24, $25, $26, $27, $00
	DB $0D, $00, $0D, $2B, $2C, $2D, $2D, $2F
	DB $40, $41, $42
;index for lower side of letters
CannonTextLowerIndex:
	DB $0F, $1A, $1B, $1C, $1D, $1E, $1F, $30
	DB $31, $11, $33, $34, $35, $36, $37, $10
	DB $38, $39, $3A, $3B, $11, $10, $3E, $3F
	DB $50, $11, $52

;"Group" text
Group_Metroid:			DB !_, !_, !_, !M, !E, !T, !R, !O, !I, !D, !End
Group_Gems:				DB !_, !_, !_, !_, !G, !E, !M, !S, !End
Group_Metal:			DB !_, !_, !_, !_, !M, !E, !T, !A, !L, !End
Group_Painted:			DB !_, !_, !_, !_, !M, !I, !X, !E, !D, !End
Group_Miscellaneous:	DB !M, !I, !S, !C, !E, !L, !L, !A, !N, !E, !O, !U, !S

;"Metroid" grouup
N_00: DB !_, !_, !_, !D, !E, !F, !A, !U, !L, !T, !End
N_02: DB !_, !_, !_, !B, !E, !A, !M, !_, !C, !O, !L, !O, !R
N_04: DB !_, !_, !_, !I, !C, !E, !_, !B, !E, !A, !M, !End
N_06: DB !_, !_, !_, !W, !A, !V, !E, !_, !B, !E, !A, !M, !End
N_08: DB !_, !_, !_, !S, !P, !A, !Z, !E, !R, !End
N_0A: DB !_, !_, !_, !P, !L, !A, !S, !M, !A, !End
N_0C: DB !P, !B, !_, !B, !E, !A, !M, !_, !C, !O, !L, !O, !R
N_0E: DB !P, !B, !_, !I, !C, !E, !_, !B, !E, !A, !M, !End
N_10: DB !P, !B, !_, !W, !A, !V, !E, !_, !B, !E, !A, !M, !End
N_12: DB !P, !B, !_, !S, !P, !A, !Z, !E, !R, !End
N_14: DB !P, !B, !_, !P, !L, !A, !S, !M, !A, !End

;"Gems" grouup
G_16: DB !_, !_, !_, !_, !R, !U, !B, !Y, !End
G_18: DB !_, !_, !_, !P, !E, !R, !I, !D, !O, !T, !End
G_1A: DB !_, !_, !_, !S, !A, !P, !P, !H, !I, !R, !E, !End
G_1C: DB !_, !_, !T, !O, !U, !R, !M, !A, !L, !I, !N, !E, !End
G_1E: DB !_, !_, !_, !C, !I, !T, !R, !I, !N, !E, !End
G_20: DB !_, !_, !_, !_, !Z, !I, !R, !C, !O, !N, !End
G_22: DB !_, !_, !_, !_, !G, !A, !R, !N, !E, !T, !End
G_24: DB !_, !_, !_, !A, !M, !E, !T, !H, !Y, !S, !T, !End
G_26: DB !_, !_, !A, !Q, !U, !A, !M, !A, !R, !I, !N, !E, !End
G_28: DB !_, !_, !_, !D, !I, !A, !M, !O, !N, !D, !End
G_2A: DB !_, !_, !_, !E, !M, !E, !R, !A, !L, !D, !End
G_2C: DB !_, !A, !L, !E, !X, !A, !N, !D, !R, !I, !T, !E, !End
G_2E: DB !_, !_, !R, !H, !O, !D, !O, !L, !I, !T, !E, !End
G_30: DB !_, !_, !_, !_, !O, !N, !Y, !X, !End
G_32: DB !_, !_, !_, !_, !O, !P, !A, !L, !End
G_34: DB !_, !_, !_, !_, !T, !O, !P, !A, !Z, !End

;"Metal" grouup
M_36: DB !_, !_, !_, !_, !I, !R, !O, !N, !End
M_38: DB !_, !_, !_, !C, !O, !P, !P, !E, !R, !End
M_3A: DB !_, !_, !_, !B, !R, !O, !N, !Z, !E, !End
M_3C: DB !_, !_, !_, !_, !G, !O, !L, !D, !End
M_3E: DB !_, !_, !A, !L, !U, !M, !I, !N, !U, !M, !End
M_40: DB !_, !_, !G, !R, !A, !P, !H, !I, !T, !E, !End
M_42: DB !_, !_, !_, !_, !S, !T, !E, !E, !L, !End
M_44: DB !_, !_, !R, !E, !D, !_, !S, !T, !E, !E, !L, !End
M_46: DB !_, !G, !R, !E, !E, !N, !_, !S, !T, !E, !E, !L, !End
M_48: DB !_, !B, !L, !U, !E, !_, !S, !T, !E, !E, !L, !End

;"Mixed" grouup
X_4A: DB !_, !_, !_, !_, !F, !L, !A, !M, !E, !End
X_4C: DB !_, !G, !R, !E, !E, !N, !_, !F, !L, !A, !M, !E, !End
X_4E: DB !_, !_, !B, !L, !U, !E, !_, !F, !L, !A, !M, !E, !End
X_50: DB !_, !Y, !_, !G, !R, !A, !D, !I, !E, !N, !T, !End
X_52: DB !_, !C, !_, !G, !R, !A, !D, !I, !E, !N, !T, !End
X_54: DB !_, !V, !_, !G, !R, !A, !D, !I, !E, !N, !T, !End
X_56: DB !_, !_, !_, !_, !O, !C, !E, !A, !N, !End
X_58: DB !_, !_, !_, !M, !I, !D, !N, !I, !G, !H, !T, !End
X_5A: DB !_, !_, !_, !N, !U, !C, !L, !E, !A, !R, !End
X_5C: DB !_, !_, !_, !_, !L, !O, !V, !E, !End
X_5E: DB !_, !_, !_, !_, !B, !L, !I, !S, !S, !End
X_60: DB !_, !_, !_, !_, !V, !O, !I, !D, !End

;"Miscellaneous" grouup
A_62: DB !C, !A, !S, !E, !_, !H, !A, !R, !D, !E, !N, !E, !D
A_64: DB !B, !L, !A, !C, !K, !_, !N, !_, !W, !H, !I, !T, !E
A_66: DB !_, !_, !C, !I, !N, !E, !M, !A, !T, !I, !C, !End
A_68: DB !_, !_, !I, !N, !V, !E, !R, !T, !E, !D, !End
}
;---------------------------------------------------------------------------------------------------
;|x|									BANK $??		Cannon palette routine					 |x|
;---------------------------------------------------------------------------------------------------
{ ORG !BankFreeSpace
;For transitional:
;$20 = source palette pointer
;$22 = positive fading value (target color)
;$C400 = numerator
;$C402 = denumerator
;$C404 = colorindex

;For fading:
;$20 = source palette pointer
;$22 = positive fading value
;$24 = negative fading value
;$C404 = colorindex

ChargeSetup:
	PHB : PEA $7E7E : PLB : PLB
	LDA $0A6E : CMP #$0004 : BEQ PseudoScrewAttackSetup
	LDX !ChargeIndex : LDA.l ChargeNumeratorIndex,x : STA !Numerator	;set numerator
	LDA #$0010 : STA !Denumerator										;set denumerator
	LDA.l ChargePos,x : STA !DPSourcePositiveFading			;set positive fading value from charge
	LDA.l ChargeNeg,x : STA !DPSourceNegativeFading			;set negative fading value from charge
	JSR CannonPaletteOffsetFinder							;set source palette pointer
	JSR !Charge												;to "Transitional" or "Fading"
	PLB : CLC : RTL

;Pseudo screw attack uses shinespark palette
PseudoScrewAttackSetup:
	LDX !ChargeIndex : LDA.l PseudoScrewAttackNumeratorIndex,x : STA !Numerator
	LDA #$0010 : STA !Denumerator
	LDA.l PseudoScrewAttackPos,x : STA !DPSourcePositiveFading
	LDA.l PseudoScrewAttackNeg,x : STA !DPSourceNegativeFading
	JSR CannonPaletteOffsetFinder
	JSR !ShineSpark											;to "Transitional" or "Fading"
	PLB : CLC : RTL

DeathSetup:		;uses charge palette
	PHB : PEA $7E7E : PLB : PLB
	LDA !DeathSequenceIndex : BEQ +
	CMP #$0001 : BEQ +++			;if death frame index equals 1, return
	DEC : ASL : TAX
+ : LDA.l DeathSequenceNumeratorIndex,x : STA !Numerator
	LDA #$0010 : STA !Denumerator
	LDA.l DeathSequencePos,x : STA !DPSourcePositiveFading
	LDA.l DeathSequenceNeg,x : STA !DPSourceNegativeFading
	JSR CannonPaletteOffsetFinder
	JSR !Charge												;to "Transitional" or "Fading"
+++ : PLB : CLC : RTL

SpeedBoosterSetup:
	PHB : PEA $7E7E : PLB : PLB
	LDX !ActionIndex : LDA.l SpeedBoosterNumeratorIndex,x : STA !Numerator
	LDA #$0010 : STA !Denumerator
	LDA.l SpeedBoosterPos,x : STA !DPSourcePositiveFading
	LDA.l SpeedBoosterNeg,x : STA !DPSourceNegativeFading
	JSR CannonPaletteOffsetFinder
	JSR !SpeedBooster										;to "Transitional" or "Fading"
	PLB : CLC : RTL

ShineSetup:
	PHB : PEA $7E7E : PLB : PLB
	LDX !ActionIndex : LDA.l ShineNumeratorIndex,x : STA !Numerator
	LDA #$0010 : STA !Denumerator
	LDA.l ShinePos,x : STA !DPSourcePositiveFading
	LDA.l ShineNeg,x : STA !DPSourceNegativeFading
	JSR CannonPaletteOffsetFinder
	JSR !Shine												;to "Transitional" or "Fading"
	PLB : CLC : RTL

ShineSparkSetup:
	PHB : PEA $7E7E : PLB : PLB
	LDX !ActionIndex : LDA.l ShineSparkNumeratorIndex,x : STA !Numerator
	LDA #$0010 : STA !Denumerator
	LDA.l ShineSparkPos,x : STA !DPSourcePositiveFading
	LDA.l ShineSparkNeg,x : STA !DPSourceNegativeFading
	JSR CannonPaletteOffsetFinder
	JSR !ShineSpark											;to "Transitional" or "Fading"
	PLB : CLC : RTL

ScrewAttack:
	PHB : PEA $7E7E : PLB : PLB
	LDX !ActionIndex : LDA.l ScrewAttackNumeratorIndex,x : STA !Numerator
	LDA #$0010 : STA !Denumerator
	LDA.l ScrewAttackPos,x : STA !DPSourcePositiveFading
	LDA.l ScrewAttackNeg,x : STA !DPSourceNegativeFading
	JSR CannonPaletteOffsetFinder
	JSR !ScrewAttack										;to "Transitional" or "Fading"
	PLB : CLC : RTL


InitialiseBeamShine:
	PHB : PEA $7E7E : PLB : PLB
	LDA $0B18 : ASL : BMI ++						;check if "fading" or "fixed"
	LSR : AND #$00FF : STA $0B18 : BEQ + : ASL		;fading: filter to timer only and execute beam shine
	JSR TransitionBeamShine							;
+ : PLB : CLC : RTL									;if timer is zero, skip beam glow

++ : LSR : AND #$3F00 : XBA : BEQ +					;fixed: execute beam shine with numerator based on "fixed beam shine"
	JSR TransitionBeamShine							;
	LDA $0B18 : AND #$40FF : INC : STA $0B18		;filter with timer and "fixed beam shine" bit set, then return
	PLB : CLC : RTL									;
+ : STZ $0B18 : PLB : CLC : RTL						;if "fixed beam shine" is zero, skip beam glow and set timer to zero

BeamShine:
	PHB : PEA $7E7E : PLB : PLB
	DEC $0B18 : BEQ +				;decrement timer, if zero, return carry set (load normal samus palette)
	LDA $0B18 : ASL : BMI ++		;branch if "fixed beam shine" bit set
	JSR TransitionBeamShine
	PLB : CLC : RTL					;return carry clear
+ : PLB : SEC : RTL

++ : PLB : AND #$00FF : BEQ +		;filter to just timer
	CLC : RTL						;
+ : STZ $0B18 : SEC : RTL			;if zero, remove "fixed beam shine" bit, return carry set (load normal samus palette)


LoadStationSetup:	;uses speed booster palette
	PHB : PEA $7E7E : PLB : PLB	: PHY : PHX
	TAX : STA !Numerator
	LDA #$0010 : STA !Denumerator
	LDA.l SpeedBoosterPos,x : STA !DPSourcePositiveFading
	LDA.l SpeedBoosterNeg,x : STA !DPSourceNegativeFading
	JSR CannonPaletteOffsetFinder
	JSR !SpeedBooster									;to "Transitional" or "Fading"
	BRA FXReturn

FXHeatGlowSetup:
	PHB : PEA $7E7E : PLB : PLB	: PHY : PHX
	LDA !HeatGlowIndex : ASL : TAX : LDA.l HeatGlowNumeratorIndex,x : STA !Numerator
	LDA #$0010 : STA !Denumerator
	LDA.l HeatGlowPos,x : STA !DPSourcePositiveFading
	LDA.l HeatGlowNeg,x : STA !DPSourceNegativeFading
	JSR CannonPaletteOffsetFinder
	JSR !HeatGlow										;to "Transitional" or "Fading"
FXReturn:
	PLX : PLY : PLB
	CLC : RTL


;---------------------------------------Fading------------------------------------------------------
Fading:
	TDC		;zero color index

- : STA !ColorIndex
	LDA [!DPSourcePalette] : JSR FadingColorCalculator

	;save color
	LDX !ColorIndex : LDA.l CannonPalettePosition,x
	TAX : TYA : STA $0000,x
	INC !DPSourcePalette : INC !DPSourcePalette
	LDA !ColorIndex : INC : INC : CMP #!PaletteChangeAmount*2 : BCC -
	
	TDC : STA !Numerator : RTS

;$05,s = result
;$03,s = add / subtraction value
;$01,s = source color
FadingColorCalculator:
	PHA : PHA : PHA
	LDX !DPSourcePositiveFading : BEQ .minus		;skip addition, if positive fading value is zero
;red +
	TDC : STA $05,s				;zero result for not interfer final result
	TXA : AND #$001F : STA $03,s				;filter component of target
	LDA $01,s : AND #$001F : CLC : ADC $03,s	;filter component of source and add with target
	CMP #$0020 : BCC + : LDA #$001F				;adjust if component value is over range
+ : STA $05,s									;save to result
;green +
	TXA : AND #$03E0 : STA $03,s
	LDA $01,s : AND #$03E0 : CLC : ADC $03,s
	CMP #$0400 : BCC + : LDA #$03E0
+ : ORA $05,s : STA $05,s
;blue +
	TXA : AND #$7C00 : STA $03,s
	LDA $01,s : AND #$7C00 : CLC : ADC $03,s
	BPL + : LDA #$7C00
+ : ORA $05,s : STA $05,s 						;final result
	STA $01,s									;set final result to source in case of negative fading values

.minus
	LDX !DPSourceNegativeFading : BEQ .return		;skip subtraction, if negative fading value is zero
;red -
	TDC : STA $05,s				;zero result for not interfer final result
	TXA : AND #$001F : STA $03,s				;filter component of target
	LDA $01,s : AND #$001F : SEC : SBC $03,s	;filter component of source and subtract with target
	BPL + : TDC									;set to zero if component value is negative
+ : STA $05,s									;save to result
;green -
	TXA : AND #$03E0 : STA $03,s
	LDA $01,s : AND #$03E0 : SEC : SBC $03,s
	BPL + : TDC
+ : ORA $05,s : STA $05,s
;blue -
	TXA : AND #$7C00 : STA $03,s
	LDA $01,s : AND #$7C00 : SEC : SBC $03,s
	BPL + : TDC
+ : ORA $05,s : STA $05,s 		;final result

.return : PLA : PLA : PLY : RTS					;return [Y] = result color


;---------------------------------------Transition--------------------------------------------------
;[A] = numerator
TransitionBeamShine:		;used for beam shine
	STA !Numerator														;set numerator (glow duration)
	LDA #$0010 : STA !Denumerator										;set denumerator
	LDA.w !BeamGlowTargetColor*2+$C1C0 : STA !DPSourcePositiveFading	;set target (beam palette)
	TDC																	;zero color index
- : STA !ColorIndex : TAX
	LDA $C380,x : TAX : LDY !DPSourcePositiveFading
	LDA !Numerator : JSR TransitionalColorCalculator

	;save color
	LDA !ColorIndex : TAX : TYA : STA $C180,x
	TXA : INC : INC : CMP #$0020 : BCC -

	TDC : STA !Numerator
	RTS

;Used for actions with transitional palette set
Transitional:
	TDC					;zero color index
- : STA !ColorIndex
	LDA [!DPSourcePalette] : TAX : LDY !DPSourcePositiveFading
	LDA !Numerator : JSR TransitionalColorCalculator

	;save color
	LDX !ColorIndex : LDA.l CannonPalettePosition,x
	TAX : TYA : STA $0000,x
	INC !DPSourcePalette : INC !DPSourcePalette
	LDA !ColorIndex : INC : INC : CMP #!PaletteChangeAmount*2 : BCC -
	
	TDC : STA !Numerator : RTS

;$05,s = palette change numerator
;$03,s = source color
;$01,s = target color
TransitionalColorCalculator:
	PHA : PHX : PHY
	
	LDA $01,s : ASL : AND #$003E : TAY			;prepare target color red component
	LDA $03,s : ASL : AND #$003E : TAX			;prepare source color red component
	LDA $05,s : JSR TransitionalColorComponent : LSR
	STA $04										;save red component to result color
	
	LDA $01,s : LSR #4 : AND #$003E : TAY		;prepare target color green component
	LDA $03,s : LSR #4 : AND #$003E : TAX		;prepare source color green component
	LDA $05,s : JSR	TransitionalColorComponent : ASL #4
	ORA $04 : STA $04							;add green component and save to result color
	
	LDA $01,s : LSR : XBA : AND #$003E : TAY	;prepare target color blue component
	LDA $03,s : LSR : XBA : AND #$003E : TAX	;prepare source color blue component
	LDA $05,s : JSR	TransitionalColorComponent : XBA : ASL
	ORA $04	: TAY								;add blue component and save to result color
	
	PLA : PLA : PLA
	RTS											;return [Y] = result color

TransitionalColorComponent:
	BNE +								;if numerator is 0: 
- : TXA : RTS							;component is source color
+ : CMP $C402 : BMI + : TYA : RTS		;if numerator is over denominator: component is target color

+ : STX $00 : CPY $00 : BCC +++			;if source > target
	BEQ - : STA $02 : TYA				;if source = target
- : SEC : SBC $00 : DEC #2 : ASL #3 : STA $00						;calculate offset for fiting target color component
	LDA.l TransitionSourcePointer,x : CLC : ADC $00 : ADC $02
	TAX : LDA.l !BankFreeSpace/$10000*$10000,x : AND #$00FF : RTS
+++ : EOR #$000F : INC : STA $02
	STY $00 : TXA : TYX : BRA -


;---------------------------------------Target Colors / Index---------------------------------------

;Transitional	:used as target palette, only the pos points are used
;Fading			:add / subtract from source color
;The negative value only gets used by fading routine.
;Fading routine adds positive color values from *pos first, then subtracts them from *neg.

ChargePos: DW $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF		;$7FFF = (1F,1F,1F)
ChargeNeg: DW $0000, $0000, $0000, $0000, $0000, $0000		;only the first 4 samus charge palette sets are used here

PseudoScrewAttackPos: DW $2B5A, $2B5A, $2B5A, $0000, $0000, $0000		;(1A,1A,0A);(1A,1A,0A);(1A,1A,0A);(00,00,00);(00,00,00);(00,00,00)
PseudoScrewAttackNeg: DW $0000, $0000, $0000, $0000, $0000, $0000		;uses samus shine spark palette set

DeathSequencePos: DW $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF			;$7FFF = (1F,1F,1F)
DeathSequenceNeg: DW $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000			;uses samus charge palette set

HeatGlowPos: DW $0000, $0422, $0422, $0424, $0424, $0846, $0846, $0C67	;(00,00,00);(02,01,01);(02,01,01);(04,01,01);(04,01,01);(06,02,02);(06,02,02);(07,03,03)
			 DW $0C67, $0846, $0846, $0424, $0424, $0422, $0422, $0000	;(07,03,03);(06,02,02);(06,02,02);(04,01,01);(04,01,01);(02,01,01);(02,01,01);(00,00,00)
HeatGlowNeg: DW	$0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000
			 DW $0000, $0000, $0000, $0000, $0000, $0000, $0000, $0000

SpeedBoosterPos: DW $0000, $2800, $50A0, $51E0					;(00,00,00);(00,00,0A);(00,05,14);(00,0F,14)
SpeedBoosterNeg: DW $0000, $0000, $0000, $0000

ShinePos: DW $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF			;$7FFF = (1F,1F,1F)
ShineNeg: DW $0000, $0000, $0000, $0000, $0000, $0000

ShineSparkPos: DW $0000, $154A, $0210, $2B5A					;(00,00,00);(0A,0A,05);(10,10,00);(1A,1A,0A)
ShineSparkNeg: DW $0000, $0000, $0000, $0000

ScrewAttackPos: DW $0000, $0140, $0280, $2BE0, $0280, $0140		;(00,00,00);(00,0A,00);(00,14,00);(00,1F,0A);(00,14,00);(00,0A,00)
ScrewAttackNeg: DW $0000, $0000, $0000, $0000, $0000, $0000


;These numerator index only get used by transitional routine.
;If these values equal or overextend the denumerator ($0010) the target color will be used.
ChargeNumeratorIndex:				;only the first 4 samus charge palette sets are used here
	DW $0000, $0002, $0004, $0006, $0004, $0002

PseudoScrewAttackNumeratorIndex:	;uses samus shine spark palette set
	DW $0006, $0006, $0006, $0000, $0000, $0000

DeathSequenceNumeratorIndex:		;uses samus charge palette set
	DW $0000, $0002, $0004, $0006, $0008, $000A, $000C, $000E

HeatGlowNumeratorIndex:
	DW $0000, $0002, $0002, $0004, $0004, $0006, $0006, $0008
	DW $0008, $0006, $0006, $0004, $0004, $0002, $0002, $0000

SpeedBoosterNumeratorIndex:			;also used by load save station routine
	DW $0000, $0002, $0004, $0006

ShineNumeratorIndex:
	DW $0000, $0004, $0008, $000C, $0008, $0004

ShineSparkNumeratorIndex:
	DW $0000, $0002, $0004, $0006

ScrewAttackNumeratorIndex:
	DW $0000, $0002, $0004, $0006, $0004, $0002


;---------------------------------------Misc.-------------------------------------------------------

UpdatePaletterAfterItemPickup:
	JSL $90AC8D		;update beam GFX (vanilla)
	JSL $91DEBA		;load normal samus palette with updated arm cannon palette
	RTL

CannonPaletteOffsetFinder:
	LDA !CannonPalette : CMP #$0002 : BEQ +			;check if "Beam Color" is active
	CMP #$000C : BEQ ++								;check if "PB Beam Color" is active
- : TAX : LDA.l PalettePointer,x : STA !DPSourcePalette				;save cannon color set pointer
	LDA #!BankCannonPalette/$10000 : STA !DPSourcePaletteBank : RTS	;save cannon color bank
+ : LDA $09A6 : AND #$000F : ASL : TAX : LDA.l BeamCannonMFPointer,x : BRA -
++ : LDA $09A6 : AND #$000F : ASL : TAX : LDA.l BeamCannonPBPointer,x : BRA -

BeamCannonMFPointer:
	DW $0000, $0006, $0004, $0004
	DW $0008, $0006, $0004, $0004
	DW $000A, $000A, $0004, $0004

BeamCannonPBPointer:
	DW $0000, $0010, $000E, $000E
	DW $0012, $0010, $000E, $000E
	DW $0014, $0014, $000E, $000E

CannonPalettePosition:
	DW !TargetPalette0*2+$C180, !TargetPalette1*2+$C180, !TargetPalette2*2+$C180, !TargetPalette3*2+$C180

BeamGlowDurationNormalShot:
	JSL $90B197
	LDA $09A6 : BIT #$1000 : BEQ +
	;beam glow characteristics for normal shots
	LDA.w #!BeamGlowFixedBitNormal*$40+!BeamGlowFixedTransitionNormal*$100+!BeamGlowDurationNormal+$8000 : STA $0B18
+ : RTL

PalettePointer:
	;"Metroid"
	DW Cannon_N_00, Cannon_N_00, Cannon_N_04, Cannon_N_06
	DW Cannon_N_08, Cannon_N_0A, Cannon_N_00, Cannon_N_0E
	DW Cannon_N_10, Cannon_N_12, Cannon_N_14
	;"Gems"
	DW Cannon_G_16, Cannon_G_18, Cannon_G_1A, Cannon_G_1C
	DW Cannon_G_1E, Cannon_G_20, Cannon_G_22, Cannon_G_24
	DW Cannon_G_26, Cannon_G_28, Cannon_G_2A, Cannon_G_2C
	DW Cannon_G_2E, Cannon_G_30, Cannon_G_32, Cannon_G_34
	;"Metal"
	DW Cannon_M_36, Cannon_M_38, Cannon_M_3A, Cannon_M_3C
	DW Cannon_M_3E, Cannon_M_40, Cannon_M_42, Cannon_M_44
	DW Cannon_M_46, Cannon_M_48
	;"Mixed"
	DW Cannon_X_4A, Cannon_X_4C, Cannon_X_4E, Cannon_X_50
	DW Cannon_X_52, Cannon_X_54, Cannon_X_56, Cannon_X_58
	DW Cannon_X_5A, Cannon_X_5C, Cannon_X_5E, Cannon_X_60
	;"Miscellaneous"
	DW Cannon_A_62, Cannon_A_64, Cannon_A_66, Cannon_A_68
}
;---------------------------------------------------------------------------------------------------
;|x|									BANK $??		Transition value table					 |x|
;---------------------------------------------------------------------------------------------------
{ ORG !BankTransitionTable
TransitionSourcePointer:
	DW TransitionSource00, TransitionSource01, TransitionSource02, TransitionSource03
	DW TransitionSource04, TransitionSource05, TransitionSource06, TransitionSource07
	DW TransitionSource08, TransitionSource09, TransitionSource0A, TransitionSource0B
	DW TransitionSource0C, TransitionSource0D, TransitionSource0E, TransitionSource0F
	DW TransitionSource10, TransitionSource11, TransitionSource12, TransitionSource13
	DW TransitionSource14, TransitionSource15, TransitionSource16, TransitionSource17
	DW TransitionSource18, TransitionSource19, TransitionSource1A, TransitionSource1B
	DW TransitionSource1C, TransitionSource1D, TransitionSource1E


TransitionSource00:
	DB $00, $00, $00, $00 : DB $00, $00, $00, $00 : DB $02, $02, $02, $02 : DB $02, $02, $02, $02
	DB $00, $00, $00, $00 : DB $02, $02, $02, $02 : DB $02, $02, $02, $02 : DB $04, $04, $04, $04
	DB $00, $00, $00, $02 : DB $02, $02, $02, $02 : DB $04, $04, $04, $04 : DB $04, $04, $06, $06
	DB $00, $00, $02, $02 : DB $02, $02, $04, $04 : DB $04, $04, $06, $06 : DB $06, $06, $08, $08
	DB $00, $00, $02, $02 : DB $02, $04, $04, $04 : DB $06, $06, $06, $06 : DB $08, $08, $08, $0A
	DB $00, $00, $02, $02 : DB $04, $04, $04, $06 : DB $06, $06, $08, $08 : DB $0A, $0A, $0A, $0C
	DB $00, $00, $02, $02 : DB $04, $04, $06, $06 : DB $08, $08, $08, $0A : DB $0A, $0C, $0C, $0E
	DB $00, $02, $02, $04 : DB $04, $06, $06, $08 : DB $08, $0A, $0A, $0C : DB $0C, $0E, $0E, $10
	DB $00, $02, $02, $04 : DB $04, $06, $06, $08 : DB $0A, $0A, $0C, $0C : DB $0E, $0E, $10, $10
	DB $00, $02, $02, $04 : DB $06, $06, $08, $08 : DB $0A, $0C, $0C, $0E : DB $10, $10, $12, $12
	DB $00, $02, $02, $04 : DB $06, $06, $08, $0A : DB $0C, $0C, $0E, $10 : DB $10, $12, $14, $14
	DB $00, $02, $04, $04 : DB $06, $08, $0A, $0A : DB $0C, $0E, $10, $10 : DB $12, $14, $16, $16
	DB $00, $02, $04, $04 : DB $06, $08, $0A, $0C : DB $0E, $0E, $10, $12 : DB $14, $16, $16, $18
	DB $00, $02, $04, $06 : DB $08, $08, $0A, $0C : DB $0E, $10, $12, $14 : DB $16, $16, $18, $1A
	DB $00, $02, $04, $06 : DB $08, $0A, $0C, $0E : DB $10, $10, $12, $14 : DB $16, $18, $1A, $1C
	DB $00, $02, $04, $06 : DB $08, $0A, $0C, $0E : DB $10, $12, $14, $16 : DB $18, $1A, $1C, $1E
	DB $00, $02, $04, $06 : DB $08, $0A, $0C, $0E : DB $12, $14, $16, $18 : DB $1A, $1C, $1E, $20
	DB $00, $02, $04, $06 : DB $0A, $0C, $0E, $10 : DB $12, $14, $16, $18 : DB $1C, $1E, $20, $22
	DB $00, $02, $04, $08 : DB $0A, $0C, $0E, $10 : DB $14, $16, $18, $1A : DB $1C, $1E, $22, $24
	DB $00, $02, $06, $08 : DB $0A, $0C, $10, $12 : DB $14, $16, $1A, $1C : DB $1E, $20, $24, $26
	DB $00, $02, $06, $08 : DB $0A, $0E, $10, $12 : DB $16, $18, $1A, $1C : DB $20, $22, $24, $28
	DB $00, $02, $06, $08 : DB $0C, $0E, $10, $14 : DB $16, $18, $1C, $1E : DB $22, $24, $26, $2A
	DB $00, $02, $06, $08 : DB $0C, $0E, $12, $14 : DB $18, $1A, $1C, $20 : DB $22, $26, $28, $2C
	DB $00, $04, $06, $0A : DB $0C, $10, $12, $16 : DB $18, $1C, $1E, $22 : DB $24, $28, $2A, $2E
	DB $00, $04, $06, $0A : DB $0C, $10, $12, $16 : DB $1A, $1C, $20, $22 : DB $26, $28, $2C, $2E
	DB $00, $04, $06, $0A : DB $0E, $10, $14, $16 : DB $1A, $1E, $20, $24 : DB $28, $2A, $2E, $30
	DB $00, $04, $06, $0A : DB $0E, $10, $14, $18 : DB $1C, $1E, $22, $26 : DB $28, $2C, $30, $32
	DB $00, $04, $08, $0A : DB $0E, $12, $16, $18 : DB $1C, $20, $24, $26 : DB $2A, $2E, $32, $34
	DB $00, $04, $08, $0A : DB $0E, $12, $16, $1A : DB $1E, $20, $24, $28 : DB $2C, $30, $32, $36
	DB $00, $04, $08, $0C : DB $10, $12, $16, $1A : DB $1E, $22, $26, $2A : DB $2E, $30, $34, $38
	DB $00, $04, $08, $0C : DB $10, $14, $18, $1C : DB $20, $22, $26, $2A : DB $2E, $32, $36, $3A

TransitionSource01:
	DB $02, $02, $02, $02 : DB $02, $02, $02, $02 : DB $04, $04, $04, $04 : DB $04, $04, $04, $04
	DB $02, $02, $02, $02 : DB $04, $04, $04, $04 : DB $04, $04, $04, $04 : DB $06, $06, $06, $06
	DB $02, $02, $02, $04 : DB $04, $04, $04, $04 : DB $06, $06, $06, $06 : DB $06, $06, $08, $08
	DB $02, $02, $04, $04 : DB $04, $04, $06, $06 : DB $06, $06, $08, $08 : DB $08, $08, $0A, $0A
	DB $02, $02, $04, $04 : DB $04, $06, $06, $06 : DB $08, $08, $08, $08 : DB $0A, $0A, $0A, $0C
	DB $02, $02, $04, $04 : DB $06, $06, $06, $08 : DB $08, $08, $0A, $0A : DB $0C, $0C, $0C, $0E
	DB $02, $02, $04, $04 : DB $06, $06, $08, $08 : DB $0A, $0A, $0A, $0C : DB $0C, $0E, $0E, $10
	DB $02, $04, $04, $06 : DB $06, $08, $08, $0A : DB $0A, $0C, $0C, $0E : DB $0E, $10, $10, $12
	DB $02, $04, $04, $06 : DB $06, $08, $08, $0A : DB $0C, $0C, $0E, $0E : DB $10, $10, $12, $12
	DB $02, $04, $04, $06 : DB $08, $08, $0A, $0A : DB $0C, $0E, $0E, $10 : DB $12, $12, $14, $14
	DB $02, $04, $04, $06 : DB $08, $08, $0A, $0C : DB $0E, $0E, $10, $12 : DB $12, $14, $16, $16
	DB $02, $04, $06, $06 : DB $08, $0A, $0C, $0C : DB $0E, $10, $12, $12 : DB $14, $16, $18, $18
	DB $02, $04, $06, $06 : DB $08, $0A, $0C, $0E : DB $10, $10, $12, $14 : DB $16, $18, $18, $1A
	DB $02, $04, $06, $08 : DB $0A, $0A, $0C, $0E : DB $10, $12, $14, $16 : DB $18, $18, $1A, $1C
	DB $02, $04, $06, $08 : DB $0A, $0C, $0E, $10 : DB $12, $12, $14, $16 : DB $18, $1A, $1C, $1E
	DB $02, $04, $06, $08 : DB $0A, $0C, $0E, $10 : DB $12, $14, $16, $18 : DB $1A, $1C, $1E, $20
	DB $02, $04, $06, $08 : DB $0A, $0C, $0E, $10 : DB $14, $16, $18, $1A : DB $1C, $1E, $20, $22
	DB $02, $04, $06, $08 : DB $0C, $0E, $10, $12 : DB $14, $16, $18, $1A : DB $1E, $20, $22, $24
	DB $02, $04, $06, $0A : DB $0C, $0E, $10, $12 : DB $16, $18, $1A, $1C : DB $1E, $20, $24, $26
	DB $02, $04, $08, $0A : DB $0C, $0E, $12, $14 : DB $16, $18, $1C, $1E : DB $20, $22, $26, $28
	DB $02, $04, $08, $0A : DB $0C, $10, $12, $14 : DB $18, $1A, $1C, $1E : DB $22, $24, $26, $2A
	DB $02, $04, $08, $0A : DB $0E, $10, $12, $16 : DB $18, $1A, $1E, $20 : DB $24, $26, $28, $2C
	DB $02, $04, $08, $0A : DB $0E, $10, $14, $16 : DB $1A, $1C, $1E, $22 : DB $24, $28, $2A, $2E
	DB $02, $06, $08, $0C : DB $0E, $12, $14, $18 : DB $1A, $1E, $20, $24 : DB $26, $2A, $2C, $30
	DB $02, $06, $08, $0C : DB $0E, $12, $14, $18 : DB $1C, $1E, $22, $24 : DB $28, $2A, $2E, $30
	DB $02, $06, $08, $0C : DB $10, $12, $16, $18 : DB $1C, $20, $22, $26 : DB $2A, $2C, $30, $32
	DB $02, $06, $08, $0C : DB $10, $12, $16, $1A : DB $1E, $20, $24, $28 : DB $2A, $2E, $32, $34
	DB $02, $06, $0A, $0C : DB $10, $14, $18, $1A : DB $1E, $22, $26, $28 : DB $2C, $30, $34, $36
	DB $02, $06, $0A, $0C : DB $10, $14, $18, $1C : DB $20, $22, $26, $2A : DB $2E, $32, $34, $38
	DB $02, $06, $0A, $0E : DB $12, $14, $18, $1C : DB $20, $24, $28, $2C : DB $30, $32, $36, $3A

TransitionSource02:
	DB $04, $04, $04, $04 : DB $04, $04, $04, $04 : DB $06, $06, $06, $06 : DB $06, $06, $06, $06
	DB $04, $04, $04, $04 : DB $06, $06, $06, $06 : DB $06, $06, $06, $06 : DB $08, $08, $08, $08
	DB $04, $04, $04, $06 : DB $06, $06, $06, $06 : DB $08, $08, $08, $08 : DB $08, $08, $0A, $0A
	DB $04, $04, $06, $06 : DB $06, $06, $08, $08 : DB $08, $08, $0A, $0A : DB $0A, $0A, $0C, $0C
	DB $04, $04, $06, $06 : DB $06, $08, $08, $08 : DB $0A, $0A, $0A, $0A : DB $0C, $0C, $0C, $0E
	DB $04, $04, $06, $06 : DB $08, $08, $08, $0A : DB $0A, $0A, $0C, $0C : DB $0E, $0E, $0E, $10
	DB $04, $04, $06, $06 : DB $08, $08, $0A, $0A : DB $0C, $0C, $0C, $0E : DB $0E, $10, $10, $12
	DB $04, $06, $06, $08 : DB $08, $0A, $0A, $0C : DB $0C, $0E, $0E, $10 : DB $10, $12, $12, $14
	DB $04, $06, $06, $08 : DB $08, $0A, $0A, $0C : DB $0E, $0E, $10, $10 : DB $12, $12, $14, $14
	DB $04, $06, $06, $08 : DB $0A, $0A, $0C, $0C : DB $0E, $10, $10, $12 : DB $14, $14, $16, $16
	DB $04, $06, $06, $08 : DB $0A, $0A, $0C, $0E : DB $10, $10, $12, $14 : DB $14, $16, $18, $18
	DB $04, $06, $08, $08 : DB $0A, $0C, $0E, $0E : DB $10, $12, $14, $14 : DB $16, $18, $1A, $1A
	DB $04, $06, $08, $08 : DB $0A, $0C, $0E, $10 : DB $12, $12, $14, $16 : DB $18, $1A, $1A, $1C
	DB $04, $06, $08, $0A : DB $0C, $0C, $0E, $10 : DB $12, $14, $16, $18 : DB $1A, $1A, $1C, $1E
	DB $04, $06, $08, $0A : DB $0C, $0E, $10, $12 : DB $14, $14, $16, $18 : DB $1A, $1C, $1E, $20
	DB $04, $06, $08, $0A : DB $0C, $0E, $10, $12 : DB $14, $16, $18, $1A : DB $1C, $1E, $20, $22
	DB $04, $06, $08, $0A : DB $0C, $0E, $10, $12 : DB $16, $18, $1A, $1C : DB $1E, $20, $22, $24
	DB $04, $06, $08, $0A : DB $0E, $10, $12, $14 : DB $16, $18, $1A, $1C : DB $20, $22, $24, $26
	DB $04, $06, $08, $0C : DB $0E, $10, $12, $14 : DB $18, $1A, $1C, $1E : DB $20, $22, $26, $28
	DB $04, $06, $0A, $0C : DB $0E, $10, $14, $16 : DB $18, $1A, $1E, $20 : DB $22, $24, $28, $2A
	DB $04, $06, $0A, $0C : DB $0E, $12, $14, $16 : DB $1A, $1C, $1E, $20 : DB $24, $26, $28, $2C
	DB $04, $06, $0A, $0C : DB $10, $12, $14, $18 : DB $1A, $1C, $20, $22 : DB $26, $28, $2A, $2E
	DB $04, $06, $0A, $0C : DB $10, $12, $16, $18 : DB $1C, $1E, $20, $24 : DB $26, $2A, $2C, $30
	DB $04, $08, $0A, $0E : DB $10, $14, $16, $1A : DB $1C, $20, $22, $26 : DB $28, $2C, $2E, $32
	DB $04, $08, $0A, $0E : DB $10, $14, $16, $1A : DB $1E, $20, $24, $26 : DB $2A, $2C, $30, $32
	DB $04, $08, $0A, $0E : DB $12, $14, $18, $1A : DB $1E, $22, $24, $28 : DB $2C, $2E, $32, $34
	DB $04, $08, $0A, $0E : DB $12, $14, $18, $1C : DB $20, $22, $26, $2A : DB $2C, $30, $34, $36
	DB $04, $08, $0C, $0E : DB $12, $16, $1A, $1C : DB $20, $24, $28, $2A : DB $2E, $32, $36, $38
	DB $04, $08, $0C, $0E : DB $12, $16, $1A, $1E : DB $22, $24, $28, $2C : DB $30, $34, $36, $3A

TransitionSource03:
	DB $06, $06, $06, $06 : DB $06, $06, $06, $06 : DB $08, $08, $08, $08 : DB $08, $08, $08, $08
	DB $06, $06, $06, $06 : DB $08, $08, $08, $08 : DB $08, $08, $08, $08 : DB $0A, $0A, $0A, $0A
	DB $06, $06, $06, $08 : DB $08, $08, $08, $08 : DB $0A, $0A, $0A, $0A : DB $0A, $0A, $0C, $0C
	DB $06, $06, $08, $08 : DB $08, $08, $0A, $0A : DB $0A, $0A, $0C, $0C : DB $0C, $0C, $0E, $0E
	DB $06, $06, $08, $08 : DB $08, $0A, $0A, $0A : DB $0C, $0C, $0C, $0C : DB $0E, $0E, $0E, $10
	DB $06, $06, $08, $08 : DB $0A, $0A, $0A, $0C : DB $0C, $0C, $0E, $0E : DB $10, $10, $10, $12
	DB $06, $06, $08, $08 : DB $0A, $0A, $0C, $0C : DB $0E, $0E, $0E, $10 : DB $10, $12, $12, $14
	DB $06, $08, $08, $0A : DB $0A, $0C, $0C, $0E : DB $0E, $10, $10, $12 : DB $12, $14, $14, $16
	DB $06, $08, $08, $0A : DB $0A, $0C, $0C, $0E : DB $10, $10, $12, $12 : DB $14, $14, $16, $16
	DB $06, $08, $08, $0A : DB $0C, $0C, $0E, $0E : DB $10, $12, $12, $14 : DB $16, $16, $18, $18
	DB $06, $08, $08, $0A : DB $0C, $0C, $0E, $10 : DB $12, $12, $14, $16 : DB $16, $18, $1A, $1A
	DB $06, $08, $0A, $0A : DB $0C, $0E, $10, $10 : DB $12, $14, $16, $16 : DB $18, $1A, $1C, $1C
	DB $06, $08, $0A, $0A : DB $0C, $0E, $10, $12 : DB $14, $14, $16, $18 : DB $1A, $1C, $1C, $1E
	DB $06, $08, $0A, $0C : DB $0E, $0E, $10, $12 : DB $14, $16, $18, $1A : DB $1C, $1C, $1E, $20
	DB $06, $08, $0A, $0C : DB $0E, $10, $12, $14 : DB $16, $16, $18, $1A : DB $1C, $1E, $20, $22
	DB $06, $08, $0A, $0C : DB $0E, $10, $12, $14 : DB $16, $18, $1A, $1C : DB $1E, $20, $22, $24
	DB $06, $08, $0A, $0C : DB $0E, $10, $12, $14 : DB $18, $1A, $1C, $1E : DB $20, $22, $24, $26
	DB $06, $08, $0A, $0C : DB $10, $12, $14, $16 : DB $18, $1A, $1C, $1E : DB $22, $24, $26, $28
	DB $06, $08, $0A, $0E : DB $10, $12, $14, $16 : DB $1A, $1C, $1E, $20 : DB $22, $24, $28, $2A
	DB $06, $08, $0C, $0E : DB $10, $12, $16, $18 : DB $1A, $1C, $20, $22 : DB $24, $26, $2A, $2C
	DB $06, $08, $0C, $0E : DB $10, $14, $16, $18 : DB $1C, $1E, $20, $22 : DB $26, $28, $2A, $2E
	DB $06, $08, $0C, $0E : DB $12, $14, $16, $1A : DB $1C, $1E, $22, $24 : DB $28, $2A, $2C, $30
	DB $06, $08, $0C, $0E : DB $12, $14, $18, $1A : DB $1E, $20, $22, $26 : DB $28, $2C, $2E, $32
	DB $06, $0A, $0C, $10 : DB $12, $16, $18, $1C : DB $1E, $22, $24, $28 : DB $2A, $2E, $30, $34
	DB $06, $0A, $0C, $10 : DB $12, $16, $18, $1C : DB $20, $22, $26, $28 : DB $2C, $2E, $32, $34
	DB $06, $0A, $0C, $10 : DB $14, $16, $1A, $1C : DB $20, $24, $26, $2A : DB $2E, $30, $34, $36
	DB $06, $0A, $0C, $10 : DB $14, $16, $1A, $1E : DB $22, $24, $28, $2C : DB $2E, $32, $36, $38
	DB $06, $0A, $0E, $10 : DB $14, $18, $1C, $1E : DB $22, $26, $2A, $2C : DB $30, $34, $38, $3A

TransitionSource04:
	DB $08, $08, $08, $08 : DB $08, $08, $08, $08 : DB $0A, $0A, $0A, $0A : DB $0A, $0A, $0A, $0A
	DB $08, $08, $08, $08 : DB $0A, $0A, $0A, $0A : DB $0A, $0A, $0A, $0A : DB $0C, $0C, $0C, $0C
	DB $08, $08, $08, $0A : DB $0A, $0A, $0A, $0A : DB $0C, $0C, $0C, $0C : DB $0C, $0C, $0E, $0E
	DB $08, $08, $0A, $0A : DB $0A, $0A, $0C, $0C : DB $0C, $0C, $0E, $0E : DB $0E, $0E, $10, $10
	DB $08, $08, $0A, $0A : DB $0A, $0C, $0C, $0C : DB $0E, $0E, $0E, $0E : DB $10, $10, $10, $12
	DB $08, $08, $0A, $0A : DB $0C, $0C, $0C, $0E : DB $0E, $0E, $10, $10 : DB $12, $12, $12, $14
	DB $08, $08, $0A, $0A : DB $0C, $0C, $0E, $0E : DB $10, $10, $10, $12 : DB $12, $14, $14, $16
	DB $08, $0A, $0A, $0C : DB $0C, $0E, $0E, $10 : DB $10, $12, $12, $14 : DB $14, $16, $16, $18
	DB $08, $0A, $0A, $0C : DB $0C, $0E, $0E, $10 : DB $12, $12, $14, $14 : DB $16, $16, $18, $18
	DB $08, $0A, $0A, $0C : DB $0E, $0E, $10, $10 : DB $12, $14, $14, $16 : DB $18, $18, $1A, $1A
	DB $08, $0A, $0A, $0C : DB $0E, $0E, $10, $12 : DB $14, $14, $16, $18 : DB $18, $1A, $1C, $1C
	DB $08, $0A, $0C, $0C : DB $0E, $10, $12, $12 : DB $14, $16, $18, $18 : DB $1A, $1C, $1E, $1E
	DB $08, $0A, $0C, $0C : DB $0E, $10, $12, $14 : DB $16, $16, $18, $1A : DB $1C, $1E, $1E, $20
	DB $08, $0A, $0C, $0E : DB $10, $10, $12, $14 : DB $16, $18, $1A, $1C : DB $1E, $1E, $20, $22
	DB $08, $0A, $0C, $0E : DB $10, $12, $14, $16 : DB $18, $18, $1A, $1C : DB $1E, $20, $22, $24
	DB $08, $0A, $0C, $0E : DB $10, $12, $14, $16 : DB $18, $1A, $1C, $1E : DB $20, $22, $24, $26
	DB $08, $0A, $0C, $0E : DB $10, $12, $14, $16 : DB $1A, $1C, $1E, $20 : DB $22, $24, $26, $28
	DB $08, $0A, $0C, $0E : DB $12, $14, $16, $18 : DB $1A, $1C, $1E, $20 : DB $24, $26, $28, $2A
	DB $08, $0A, $0C, $10 : DB $12, $14, $16, $18 : DB $1C, $1E, $20, $22 : DB $24, $26, $2A, $2C
	DB $08, $0A, $0E, $10 : DB $12, $14, $18, $1A : DB $1C, $1E, $22, $24 : DB $26, $28, $2C, $2E
	DB $08, $0A, $0E, $10 : DB $12, $16, $18, $1A : DB $1E, $20, $22, $24 : DB $28, $2A, $2C, $30
	DB $08, $0A, $0E, $10 : DB $14, $16, $18, $1C : DB $1E, $20, $24, $26 : DB $2A, $2C, $2E, $32
	DB $08, $0A, $0E, $10 : DB $14, $16, $1A, $1C : DB $20, $22, $24, $28 : DB $2A, $2E, $30, $34
	DB $08, $0C, $0E, $12 : DB $14, $18, $1A, $1E : DB $20, $24, $26, $2A : DB $2C, $30, $32, $36
	DB $08, $0C, $0E, $12 : DB $14, $18, $1A, $1E : DB $22, $24, $28, $2A : DB $2E, $30, $34, $36
	DB $08, $0C, $0E, $12 : DB $16, $18, $1C, $1E : DB $22, $26, $28, $2C : DB $30, $32, $36, $38
	DB $08, $0C, $0E, $12 : DB $16, $18, $1C, $20 : DB $24, $26, $2A, $2E : DB $30, $34, $38, $3A

TransitionSource05:
	DB $0A, $0A, $0A, $0A : DB $0A, $0A, $0A, $0A : DB $0C, $0C, $0C, $0C : DB $0C, $0C, $0C, $0C
	DB $0A, $0A, $0A, $0A : DB $0C, $0C, $0C, $0C : DB $0C, $0C, $0C, $0C : DB $0E, $0E, $0E, $0E
	DB $0A, $0A, $0A, $0C : DB $0C, $0C, $0C, $0C : DB $0E, $0E, $0E, $0E : DB $0E, $0E, $10, $10
	DB $0A, $0A, $0C, $0C : DB $0C, $0C, $0E, $0E : DB $0E, $0E, $10, $10 : DB $10, $10, $12, $12
	DB $0A, $0A, $0C, $0C : DB $0C, $0E, $0E, $0E : DB $10, $10, $10, $10 : DB $12, $12, $12, $14
	DB $0A, $0A, $0C, $0C : DB $0E, $0E, $0E, $10 : DB $10, $10, $12, $12 : DB $14, $14, $14, $16
	DB $0A, $0A, $0C, $0C : DB $0E, $0E, $10, $10 : DB $12, $12, $12, $14 : DB $14, $16, $16, $18
	DB $0A, $0C, $0C, $0E : DB $0E, $10, $10, $12 : DB $12, $14, $14, $16 : DB $16, $18, $18, $1A
	DB $0A, $0C, $0C, $0E : DB $0E, $10, $10, $12 : DB $14, $14, $16, $16 : DB $18, $18, $1A, $1A
	DB $0A, $0C, $0C, $0E : DB $10, $10, $12, $12 : DB $14, $16, $16, $18 : DB $1A, $1A, $1C, $1C
	DB $0A, $0C, $0C, $0E : DB $10, $10, $12, $14 : DB $16, $16, $18, $1A : DB $1A, $1C, $1E, $1E
	DB $0A, $0C, $0E, $0E : DB $10, $12, $14, $14 : DB $16, $18, $1A, $1A : DB $1C, $1E, $20, $20
	DB $0A, $0C, $0E, $0E : DB $10, $12, $14, $16 : DB $18, $18, $1A, $1C : DB $1E, $20, $20, $22
	DB $0A, $0C, $0E, $10 : DB $12, $12, $14, $16 : DB $18, $1A, $1C, $1E : DB $20, $20, $22, $24
	DB $0A, $0C, $0E, $10 : DB $12, $14, $16, $18 : DB $1A, $1A, $1C, $1E : DB $20, $22, $24, $26
	DB $0A, $0C, $0E, $10 : DB $12, $14, $16, $18 : DB $1A, $1C, $1E, $20 : DB $22, $24, $26, $28
	DB $0A, $0C, $0E, $10 : DB $12, $14, $16, $18 : DB $1C, $1E, $20, $22 : DB $24, $26, $28, $2A
	DB $0A, $0C, $0E, $10 : DB $14, $16, $18, $1A : DB $1C, $1E, $20, $22 : DB $26, $28, $2A, $2C
	DB $0A, $0C, $0E, $12 : DB $14, $16, $18, $1A : DB $1E, $20, $22, $24 : DB $26, $28, $2C, $2E
	DB $0A, $0C, $10, $12 : DB $14, $16, $1A, $1C : DB $1E, $20, $24, $26 : DB $28, $2A, $2E, $30
	DB $0A, $0C, $10, $12 : DB $14, $18, $1A, $1C : DB $20, $22, $24, $26 : DB $2A, $2C, $2E, $32
	DB $0A, $0C, $10, $12 : DB $16, $18, $1A, $1E : DB $20, $22, $26, $28 : DB $2C, $2E, $30, $34
	DB $0A, $0C, $10, $12 : DB $16, $18, $1C, $1E : DB $22, $24, $26, $2A : DB $2C, $30, $32, $36
	DB $0A, $0E, $10, $14 : DB $16, $1A, $1C, $20 : DB $22, $26, $28, $2C : DB $2E, $32, $34, $38
	DB $0A, $0E, $10, $14 : DB $16, $1A, $1C, $20 : DB $24, $26, $2A, $2C : DB $30, $32, $36, $38
	DB $0A, $0E, $10, $14 : DB $18, $1A, $1E, $20 : DB $24, $28, $2A, $2E : DB $32, $34, $38, $3A

TransitionSource06:
	DB $0C, $0C, $0C, $0C : DB $0C, $0C, $0C, $0C : DB $0E, $0E, $0E, $0E : DB $0E, $0E, $0E, $0E
	DB $0C, $0C, $0C, $0C : DB $0E, $0E, $0E, $0E : DB $0E, $0E, $0E, $0E : DB $10, $10, $10, $10
	DB $0C, $0C, $0C, $0E : DB $0E, $0E, $0E, $0E : DB $10, $10, $10, $10 : DB $10, $10, $12, $12
	DB $0C, $0C, $0E, $0E : DB $0E, $0E, $10, $10 : DB $10, $10, $12, $12 : DB $12, $12, $14, $14
	DB $0C, $0C, $0E, $0E : DB $0E, $10, $10, $10 : DB $12, $12, $12, $12 : DB $14, $14, $14, $16
	DB $0C, $0C, $0E, $0E : DB $10, $10, $10, $12 : DB $12, $12, $14, $14 : DB $16, $16, $16, $18
	DB $0C, $0C, $0E, $0E : DB $10, $10, $12, $12 : DB $14, $14, $14, $16 : DB $16, $18, $18, $1A
	DB $0C, $0E, $0E, $10 : DB $10, $12, $12, $14 : DB $14, $16, $16, $18 : DB $18, $1A, $1A, $1C
	DB $0C, $0E, $0E, $10 : DB $10, $12, $12, $14 : DB $16, $16, $18, $18 : DB $1A, $1A, $1C, $1C
	DB $0C, $0E, $0E, $10 : DB $12, $12, $14, $14 : DB $16, $18, $18, $1A : DB $1C, $1C, $1E, $1E
	DB $0C, $0E, $0E, $10 : DB $12, $12, $14, $16 : DB $18, $18, $1A, $1C : DB $1C, $1E, $20, $20
	DB $0C, $0E, $10, $10 : DB $12, $14, $16, $16 : DB $18, $1A, $1C, $1C : DB $1E, $20, $22, $22
	DB $0C, $0E, $10, $10 : DB $12, $14, $16, $18 : DB $1A, $1A, $1C, $1E : DB $20, $22, $22, $24
	DB $0C, $0E, $10, $12 : DB $14, $14, $16, $18 : DB $1A, $1C, $1E, $20 : DB $22, $22, $24, $26
	DB $0C, $0E, $10, $12 : DB $14, $16, $18, $1A : DB $1C, $1C, $1E, $20 : DB $22, $24, $26, $28
	DB $0C, $0E, $10, $12 : DB $14, $16, $18, $1A : DB $1C, $1E, $20, $22 : DB $24, $26, $28, $2A
	DB $0C, $0E, $10, $12 : DB $14, $16, $18, $1A : DB $1E, $20, $22, $24 : DB $26, $28, $2A, $2C
	DB $0C, $0E, $10, $12 : DB $16, $18, $1A, $1C : DB $1E, $20, $22, $24 : DB $28, $2A, $2C, $2E
	DB $0C, $0E, $10, $14 : DB $16, $18, $1A, $1C : DB $20, $22, $24, $26 : DB $28, $2A, $2E, $30
	DB $0C, $0E, $12, $14 : DB $16, $18, $1C, $1E : DB $20, $22, $26, $28 : DB $2A, $2C, $30, $32
	DB $0C, $0E, $12, $14 : DB $16, $1A, $1C, $1E : DB $22, $24, $26, $28 : DB $2C, $2E, $30, $34
	DB $0C, $0E, $12, $14 : DB $18, $1A, $1C, $20 : DB $22, $24, $28, $2A : DB $2E, $30, $32, $36
	DB $0C, $0E, $12, $14 : DB $18, $1A, $1E, $20 : DB $24, $26, $28, $2C : DB $2E, $32, $34, $38
	DB $0C, $10, $12, $16 : DB $18, $1C, $1E, $22 : DB $24, $28, $2A, $2E : DB $30, $34, $36, $3A
	DB $0C, $10, $12, $16 : DB $18, $1C, $1E, $22 : DB $26, $28, $2C, $2E : DB $32, $34, $38, $3A

TransitionSource07:
	DB $0E, $0E, $0E, $0E : DB $0E, $0E, $0E, $0E : DB $10, $10, $10, $10 : DB $10, $10, $10, $10
	DB $0E, $0E, $0E, $0E : DB $10, $10, $10, $10 : DB $10, $10, $10, $10 : DB $12, $12, $12, $12
	DB $0E, $0E, $0E, $10 : DB $10, $10, $10, $10 : DB $12, $12, $12, $12 : DB $12, $12, $14, $14
	DB $0E, $0E, $10, $10 : DB $10, $10, $12, $12 : DB $12, $12, $14, $14 : DB $14, $14, $16, $16
	DB $0E, $0E, $10, $10 : DB $10, $12, $12, $12 : DB $14, $14, $14, $14 : DB $16, $16, $16, $18
	DB $0E, $0E, $10, $10 : DB $12, $12, $12, $14 : DB $14, $14, $16, $16 : DB $18, $18, $18, $1A
	DB $0E, $0E, $10, $10 : DB $12, $12, $14, $14 : DB $16, $16, $16, $18 : DB $18, $1A, $1A, $1C
	DB $0E, $10, $10, $12 : DB $12, $14, $14, $16 : DB $16, $18, $18, $1A : DB $1A, $1C, $1C, $1E
	DB $0E, $10, $10, $12 : DB $12, $14, $14, $16 : DB $18, $18, $1A, $1A : DB $1C, $1C, $1E, $1E
	DB $0E, $10, $10, $12 : DB $14, $14, $16, $16 : DB $18, $1A, $1A, $1C : DB $1E, $1E, $20, $20
	DB $0E, $10, $10, $12 : DB $14, $14, $16, $18 : DB $1A, $1A, $1C, $1E : DB $1E, $20, $22, $22
	DB $0E, $10, $12, $12 : DB $14, $16, $18, $18 : DB $1A, $1C, $1E, $1E : DB $20, $22, $24, $24
	DB $0E, $10, $12, $12 : DB $14, $16, $18, $1A : DB $1C, $1C, $1E, $20 : DB $22, $24, $24, $26
	DB $0E, $10, $12, $14 : DB $16, $16, $18, $1A : DB $1C, $1E, $20, $22 : DB $24, $24, $26, $28
	DB $0E, $10, $12, $14 : DB $16, $18, $1A, $1C : DB $1E, $1E, $20, $22 : DB $24, $26, $28, $2A
	DB $0E, $10, $12, $14 : DB $16, $18, $1A, $1C : DB $1E, $20, $22, $24 : DB $26, $28, $2A, $2C
	DB $0E, $10, $12, $14 : DB $16, $18, $1A, $1C : DB $20, $22, $24, $26 : DB $28, $2A, $2C, $2E
	DB $0E, $10, $12, $14 : DB $18, $1A, $1C, $1E : DB $20, $22, $24, $26 : DB $2A, $2C, $2E, $30
	DB $0E, $10, $12, $16 : DB $18, $1A, $1C, $1E : DB $22, $24, $26, $28 : DB $2A, $2C, $30, $32
	DB $0E, $10, $14, $16 : DB $18, $1A, $1E, $20 : DB $22, $24, $28, $2A : DB $2C, $2E, $32, $34
	DB $0E, $10, $14, $16 : DB $18, $1C, $1E, $20 : DB $24, $26, $28, $2A : DB $2E, $30, $32, $36
	DB $0E, $10, $14, $16 : DB $1A, $1C, $1E, $22 : DB $24, $26, $2A, $2C : DB $30, $32, $34, $38
	DB $0E, $10, $14, $16 : DB $1A, $1C, $20, $22 : DB $26, $28, $2A, $2E : DB $30, $34, $36, $3A
	DB $0E, $12, $14, $18 : DB $1A, $1E, $20, $24 : DB $26, $2A, $2C, $30 : DB $32, $36, $38, $3C

TransitionSource08:
	DB $10, $10, $10, $10 : DB $10, $10, $10, $10 : DB $12, $12, $12, $12 : DB $12, $12, $12, $12
	DB $10, $10, $10, $10 : DB $12, $12, $12, $12 : DB $12, $12, $12, $12 : DB $14, $14, $14, $14
	DB $10, $10, $10, $12 : DB $12, $12, $12, $12 : DB $14, $14, $14, $14 : DB $14, $14, $16, $16
	DB $10, $10, $12, $12 : DB $12, $12, $14, $14 : DB $14, $14, $16, $16 : DB $16, $16, $18, $18
	DB $10, $10, $12, $12 : DB $12, $14, $14, $14 : DB $16, $16, $16, $16 : DB $18, $18, $18, $1A
	DB $10, $10, $12, $12 : DB $14, $14, $14, $16 : DB $16, $16, $18, $18 : DB $1A, $1A, $1A, $1C
	DB $10, $10, $12, $12 : DB $14, $14, $16, $16 : DB $18, $18, $18, $1A : DB $1A, $1C, $1C, $1E
	DB $10, $12, $12, $14 : DB $14, $16, $16, $18 : DB $18, $1A, $1A, $1C : DB $1C, $1E, $1E, $20
	DB $10, $12, $12, $14 : DB $14, $16, $16, $18 : DB $1A, $1A, $1C, $1C : DB $1E, $1E, $20, $20
	DB $10, $12, $12, $14 : DB $16, $16, $18, $18 : DB $1A, $1C, $1C, $1E : DB $20, $20, $22, $22
	DB $10, $12, $12, $14 : DB $16, $16, $18, $1A : DB $1C, $1C, $1E, $20 : DB $20, $22, $24, $24
	DB $10, $12, $14, $14 : DB $16, $18, $1A, $1A : DB $1C, $1E, $20, $20 : DB $22, $24, $26, $26
	DB $10, $12, $14, $14 : DB $16, $18, $1A, $1C : DB $1E, $1E, $20, $22 : DB $24, $26, $26, $28
	DB $10, $12, $14, $16 : DB $18, $18, $1A, $1C : DB $1E, $20, $22, $24 : DB $26, $26, $28, $2A
	DB $10, $12, $14, $16 : DB $18, $1A, $1C, $1E : DB $20, $20, $22, $24 : DB $26, $28, $2A, $2C
	DB $10, $12, $14, $16 : DB $18, $1A, $1C, $1E : DB $20, $22, $24, $26 : DB $28, $2A, $2C, $2E
	DB $10, $12, $14, $16 : DB $18, $1A, $1C, $1E : DB $22, $24, $26, $28 : DB $2A, $2C, $2E, $30
	DB $10, $12, $14, $16 : DB $1A, $1C, $1E, $20 : DB $22, $24, $26, $28 : DB $2C, $2E, $30, $32
	DB $10, $12, $14, $18 : DB $1A, $1C, $1E, $20 : DB $24, $26, $28, $2A : DB $2C, $2E, $32, $34
	DB $10, $12, $16, $18 : DB $1A, $1C, $20, $22 : DB $24, $26, $2A, $2C : DB $2E, $30, $34, $36
	DB $10, $12, $16, $18 : DB $1A, $1E, $20, $22 : DB $26, $28, $2A, $2C : DB $30, $32, $34, $38
	DB $10, $12, $16, $18 : DB $1C, $1E, $20, $24 : DB $26, $28, $2C, $2E : DB $32, $34, $36, $3A
	DB $10, $12, $16, $18 : DB $1C, $1E, $22, $24 : DB $28, $2A, $2C, $30 : DB $32, $36, $38, $3C

TransitionSource09:
	DB $12, $12, $12, $12 : DB $12, $12, $12, $12 : DB $14, $14, $14, $14 : DB $14, $14, $14, $14
	DB $12, $12, $12, $12 : DB $14, $14, $14, $14 : DB $14, $14, $14, $14 : DB $16, $16, $16, $16
	DB $12, $12, $12, $14 : DB $14, $14, $14, $14 : DB $16, $16, $16, $16 : DB $16, $16, $18, $18
	DB $12, $12, $14, $14 : DB $14, $14, $16, $16 : DB $16, $16, $18, $18 : DB $18, $18, $1A, $1A
	DB $12, $12, $14, $14 : DB $14, $16, $16, $16 : DB $18, $18, $18, $18 : DB $1A, $1A, $1A, $1C
	DB $12, $12, $14, $14 : DB $16, $16, $16, $18 : DB $18, $18, $1A, $1A : DB $1C, $1C, $1C, $1E
	DB $12, $12, $14, $14 : DB $16, $16, $18, $18 : DB $1A, $1A, $1A, $1C : DB $1C, $1E, $1E, $20
	DB $12, $14, $14, $16 : DB $16, $18, $18, $1A : DB $1A, $1C, $1C, $1E : DB $1E, $20, $20, $22
	DB $12, $14, $14, $16 : DB $16, $18, $18, $1A : DB $1C, $1C, $1E, $1E : DB $20, $20, $22, $22
	DB $12, $14, $14, $16 : DB $18, $18, $1A, $1A : DB $1C, $1E, $1E, $20 : DB $22, $22, $24, $24
	DB $12, $14, $14, $16 : DB $18, $18, $1A, $1C : DB $1E, $1E, $20, $22 : DB $22, $24, $26, $26
	DB $12, $14, $16, $16 : DB $18, $1A, $1C, $1C : DB $1E, $20, $22, $22 : DB $24, $26, $28, $28
	DB $12, $14, $16, $16 : DB $18, $1A, $1C, $1E : DB $20, $20, $22, $24 : DB $26, $28, $28, $2A
	DB $12, $14, $16, $18 : DB $1A, $1A, $1C, $1E : DB $20, $22, $24, $26 : DB $28, $28, $2A, $2C
	DB $12, $14, $16, $18 : DB $1A, $1C, $1E, $20 : DB $22, $22, $24, $26 : DB $28, $2A, $2C, $2E
	DB $12, $14, $16, $18 : DB $1A, $1C, $1E, $20 : DB $22, $24, $26, $28 : DB $2A, $2C, $2E, $30
	DB $12, $14, $16, $18 : DB $1A, $1C, $1E, $20 : DB $24, $26, $28, $2A : DB $2C, $2E, $30, $32
	DB $12, $14, $16, $18 : DB $1C, $1E, $20, $22 : DB $24, $26, $28, $2A : DB $2E, $30, $32, $34
	DB $12, $14, $16, $1A : DB $1C, $1E, $20, $22 : DB $26, $28, $2A, $2C : DB $2E, $30, $34, $36
	DB $12, $14, $18, $1A : DB $1C, $1E, $22, $24 : DB $26, $28, $2C, $2E : DB $30, $32, $36, $38
	DB $12, $14, $18, $1A : DB $1C, $20, $22, $24 : DB $28, $2A, $2C, $2E : DB $32, $34, $36, $3A
	DB $12, $14, $18, $1A : DB $1E, $20, $22, $26 : DB $28, $2A, $2E, $30 : DB $34, $36, $38, $3C

TransitionSource0A:
	DB $14, $14, $14, $14 : DB $14, $14, $14, $14 : DB $16, $16, $16, $16 : DB $16, $16, $16, $16
	DB $14, $14, $14, $14 : DB $16, $16, $16, $16 : DB $16, $16, $16, $16 : DB $18, $18, $18, $18
	DB $14, $14, $14, $16 : DB $16, $16, $16, $16 : DB $18, $18, $18, $18 : DB $18, $18, $1A, $1A
	DB $14, $14, $16, $16 : DB $16, $16, $18, $18 : DB $18, $18, $1A, $1A : DB $1A, $1A, $1C, $1C
	DB $14, $14, $16, $16 : DB $16, $18, $18, $18 : DB $1A, $1A, $1A, $1A : DB $1C, $1C, $1C, $1E
	DB $14, $14, $16, $16 : DB $18, $18, $18, $1A : DB $1A, $1A, $1C, $1C : DB $1E, $1E, $1E, $20
	DB $14, $14, $16, $16 : DB $18, $18, $1A, $1A : DB $1C, $1C, $1C, $1E : DB $1E, $20, $20, $22
	DB $14, $16, $16, $18 : DB $18, $1A, $1A, $1C : DB $1C, $1E, $1E, $20 : DB $20, $22, $22, $24
	DB $14, $16, $16, $18 : DB $18, $1A, $1A, $1C : DB $1E, $1E, $20, $20 : DB $22, $22, $24, $24
	DB $14, $16, $16, $18 : DB $1A, $1A, $1C, $1C : DB $1E, $20, $20, $22 : DB $24, $24, $26, $26
	DB $14, $16, $16, $18 : DB $1A, $1A, $1C, $1E : DB $20, $20, $22, $24 : DB $24, $26, $28, $28
	DB $14, $16, $18, $18 : DB $1A, $1C, $1E, $1E : DB $20, $22, $24, $24 : DB $26, $28, $2A, $2A
	DB $14, $16, $18, $18 : DB $1A, $1C, $1E, $20 : DB $22, $22, $24, $26 : DB $28, $2A, $2A, $2C
	DB $14, $16, $18, $1A : DB $1C, $1C, $1E, $20 : DB $22, $24, $26, $28 : DB $2A, $2A, $2C, $2E
	DB $14, $16, $18, $1A : DB $1C, $1E, $20, $22 : DB $24, $24, $26, $28 : DB $2A, $2C, $2E, $30
	DB $14, $16, $18, $1A : DB $1C, $1E, $20, $22 : DB $24, $26, $28, $2A : DB $2C, $2E, $30, $32
	DB $14, $16, $18, $1A : DB $1C, $1E, $20, $22 : DB $26, $28, $2A, $2C : DB $2E, $30, $32, $34
	DB $14, $16, $18, $1A : DB $1E, $20, $22, $24 : DB $26, $28, $2A, $2C : DB $30, $32, $34, $36
	DB $14, $16, $18, $1C : DB $1E, $20, $22, $24 : DB $28, $2A, $2C, $2E : DB $30, $32, $36, $38
	DB $14, $16, $1A, $1C : DB $1E, $20, $24, $26 : DB $28, $2A, $2E, $30 : DB $32, $34, $38, $3A
	DB $14, $16, $1A, $1C : DB $1E, $22, $24, $26 : DB $2A, $2C, $2E, $30 : DB $34, $36, $38, $3C

TransitionSource0B:
	DB $16, $16, $16, $16 : DB $16, $16, $16, $16 : DB $18, $18, $18, $18 : DB $18, $18, $18, $18
	DB $16, $16, $16, $16 : DB $18, $18, $18, $18 : DB $18, $18, $18, $18 : DB $1A, $1A, $1A, $1A
	DB $16, $16, $16, $18 : DB $18, $18, $18, $18 : DB $1A, $1A, $1A, $1A : DB $1A, $1A, $1C, $1C
	DB $16, $16, $18, $18 : DB $18, $18, $1A, $1A : DB $1A, $1A, $1C, $1C : DB $1C, $1C, $1E, $1E
	DB $16, $16, $18, $18 : DB $18, $1A, $1A, $1A : DB $1C, $1C, $1C, $1C : DB $1E, $1E, $1E, $20
	DB $16, $16, $18, $18 : DB $1A, $1A, $1A, $1C : DB $1C, $1C, $1E, $1E : DB $20, $20, $20, $22
	DB $16, $16, $18, $18 : DB $1A, $1A, $1C, $1C : DB $1E, $1E, $1E, $20 : DB $20, $22, $22, $24
	DB $16, $18, $18, $1A : DB $1A, $1C, $1C, $1E : DB $1E, $20, $20, $22 : DB $22, $24, $24, $26
	DB $16, $18, $18, $1A : DB $1A, $1C, $1C, $1E : DB $20, $20, $22, $22 : DB $24, $24, $26, $26
	DB $16, $18, $18, $1A : DB $1C, $1C, $1E, $1E : DB $20, $22, $22, $24 : DB $26, $26, $28, $28
	DB $16, $18, $18, $1A : DB $1C, $1C, $1E, $20 : DB $22, $22, $24, $26 : DB $26, $28, $2A, $2A
	DB $16, $18, $1A, $1A : DB $1C, $1E, $20, $20 : DB $22, $24, $26, $26 : DB $28, $2A, $2C, $2C
	DB $16, $18, $1A, $1A : DB $1C, $1E, $20, $22 : DB $24, $24, $26, $28 : DB $2A, $2C, $2C, $2E
	DB $16, $18, $1A, $1C : DB $1E, $1E, $20, $22 : DB $24, $26, $28, $2A : DB $2C, $2C, $2E, $30
	DB $16, $18, $1A, $1C : DB $1E, $20, $22, $24 : DB $26, $26, $28, $2A : DB $2C, $2E, $30, $32
	DB $16, $18, $1A, $1C : DB $1E, $20, $22, $24 : DB $26, $28, $2A, $2C : DB $2E, $30, $32, $34
	DB $16, $18, $1A, $1C : DB $1E, $20, $22, $24 : DB $28, $2A, $2C, $2E : DB $30, $32, $34, $36
	DB $16, $18, $1A, $1C : DB $20, $22, $24, $26 : DB $28, $2A, $2C, $2E : DB $32, $34, $36, $38
	DB $16, $18, $1A, $1E : DB $20, $22, $24, $26 : DB $2A, $2C, $2E, $30 : DB $32, $34, $38, $3A
	DB $16, $18, $1C, $1E : DB $20, $22, $26, $28 : DB $2A, $2C, $30, $32 : DB $34, $36, $3A, $3C

TransitionSource0C:
	DB $18, $18, $18, $18 : DB $18, $18, $18, $18 : DB $1A, $1A, $1A, $1A : DB $1A, $1A, $1A, $1A
	DB $18, $18, $18, $18 : DB $1A, $1A, $1A, $1A : DB $1A, $1A, $1A, $1A : DB $1C, $1C, $1C, $1C
	DB $18, $18, $18, $1A : DB $1A, $1A, $1A, $1A : DB $1C, $1C, $1C, $1C : DB $1C, $1C, $1E, $1E
	DB $18, $18, $1A, $1A : DB $1A, $1A, $1C, $1C : DB $1C, $1C, $1E, $1E : DB $1E, $1E, $20, $20
	DB $18, $18, $1A, $1A : DB $1A, $1C, $1C, $1C : DB $1E, $1E, $1E, $1E : DB $20, $20, $20, $22
	DB $18, $18, $1A, $1A : DB $1C, $1C, $1C, $1E : DB $1E, $1E, $20, $20 : DB $22, $22, $22, $24
	DB $18, $18, $1A, $1A : DB $1C, $1C, $1E, $1E : DB $20, $20, $20, $22 : DB $22, $24, $24, $26
	DB $18, $1A, $1A, $1C : DB $1C, $1E, $1E, $20 : DB $20, $22, $22, $24 : DB $24, $26, $26, $28
	DB $18, $1A, $1A, $1C : DB $1C, $1E, $1E, $20 : DB $22, $22, $24, $24 : DB $26, $26, $28, $28
	DB $18, $1A, $1A, $1C : DB $1E, $1E, $20, $20 : DB $22, $24, $24, $26 : DB $28, $28, $2A, $2A
	DB $18, $1A, $1A, $1C : DB $1E, $1E, $20, $22 : DB $24, $24, $26, $28 : DB $28, $2A, $2C, $2C
	DB $18, $1A, $1C, $1C : DB $1E, $20, $22, $22 : DB $24, $26, $28, $28 : DB $2A, $2C, $2E, $2E
	DB $18, $1A, $1C, $1C : DB $1E, $20, $22, $24 : DB $26, $26, $28, $2A : DB $2C, $2E, $2E, $30
	DB $18, $1A, $1C, $1E : DB $20, $20, $22, $24 : DB $26, $28, $2A, $2C : DB $2E, $2E, $30, $32
	DB $18, $1A, $1C, $1E : DB $20, $22, $24, $26 : DB $28, $28, $2A, $2C : DB $2E, $30, $32, $34
	DB $18, $1A, $1C, $1E : DB $20, $22, $24, $26 : DB $28, $2A, $2C, $2E : DB $30, $32, $34, $36
	DB $18, $1A, $1C, $1E : DB $20, $22, $24, $26 : DB $2A, $2C, $2E, $30 : DB $32, $34, $36, $38
	DB $18, $1A, $1C, $1E : DB $22, $24, $26, $28 : DB $2A, $2C, $2E, $30 : DB $34, $36, $38, $3A
	DB $18, $1A, $1C, $20 : DB $22, $24, $26, $28 : DB $2C, $2E, $30, $32 : DB $34, $36, $3A, $3C

TransitionSource0D:
	DB $1A, $1A, $1A, $1A : DB $1A, $1A, $1A, $1A : DB $1C, $1C, $1C, $1C : DB $1C, $1C, $1C, $1C
	DB $1A, $1A, $1A, $1A : DB $1C, $1C, $1C, $1C : DB $1C, $1C, $1C, $1C : DB $1E, $1E, $1E, $1E
	DB $1A, $1A, $1A, $1C : DB $1C, $1C, $1C, $1C : DB $1E, $1E, $1E, $1E : DB $1E, $1E, $20, $20
	DB $1A, $1A, $1C, $1C : DB $1C, $1C, $1E, $1E : DB $1E, $1E, $20, $20 : DB $20, $20, $22, $22
	DB $1A, $1A, $1C, $1C : DB $1C, $1E, $1E, $1E : DB $20, $20, $20, $20 : DB $22, $22, $22, $24
	DB $1A, $1A, $1C, $1C : DB $1E, $1E, $1E, $20 : DB $20, $20, $22, $22 : DB $24, $24, $24, $26
	DB $1A, $1A, $1C, $1C : DB $1E, $1E, $20, $20 : DB $22, $22, $22, $24 : DB $24, $26, $26, $28
	DB $1A, $1C, $1C, $1E : DB $1E, $20, $20, $22 : DB $22, $24, $24, $26 : DB $26, $28, $28, $2A
	DB $1A, $1C, $1C, $1E : DB $1E, $20, $20, $22 : DB $24, $24, $26, $26 : DB $28, $28, $2A, $2A
	DB $1A, $1C, $1C, $1E : DB $20, $20, $22, $22 : DB $24, $26, $26, $28 : DB $2A, $2A, $2C, $2C
	DB $1A, $1C, $1C, $1E : DB $20, $20, $22, $24 : DB $26, $26, $28, $2A : DB $2A, $2C, $2E, $2E
	DB $1A, $1C, $1E, $1E : DB $20, $22, $24, $24 : DB $26, $28, $2A, $2A : DB $2C, $2E, $30, $30
	DB $1A, $1C, $1E, $1E : DB $20, $22, $24, $26 : DB $28, $28, $2A, $2C : DB $2E, $30, $30, $32
	DB $1A, $1C, $1E, $20 : DB $22, $22, $24, $26 : DB $28, $2A, $2C, $2E : DB $30, $30, $32, $34
	DB $1A, $1C, $1E, $20 : DB $22, $24, $26, $28 : DB $2A, $2A, $2C, $2E : DB $30, $32, $34, $36
	DB $1A, $1C, $1E, $20 : DB $22, $24, $26, $28 : DB $2A, $2C, $2E, $30 : DB $32, $34, $36, $38
	DB $1A, $1C, $1E, $20 : DB $22, $24, $26, $28 : DB $2C, $2E, $30, $32 : DB $34, $36, $38, $3A
	DB $1A, $1C, $1E, $20 : DB $24, $26, $28, $2A : DB $2C, $2E, $30, $32 : DB $36, $38, $3A, $3C

TransitionSource0E:
	DB $1C, $1C, $1C, $1C : DB $1C, $1C, $1C, $1C : DB $1E, $1E, $1E, $1E : DB $1E, $1E, $1E, $1E
	DB $1C, $1C, $1C, $1C : DB $1E, $1E, $1E, $1E : DB $1E, $1E, $1E, $1E : DB $20, $20, $20, $20
	DB $1C, $1C, $1C, $1E : DB $1E, $1E, $1E, $1E : DB $20, $20, $20, $20 : DB $20, $20, $22, $22
	DB $1C, $1C, $1E, $1E : DB $1E, $1E, $20, $20 : DB $20, $20, $22, $22 : DB $22, $22, $24, $24
	DB $1C, $1C, $1E, $1E : DB $1E, $20, $20, $20 : DB $22, $22, $22, $22 : DB $24, $24, $24, $26
	DB $1C, $1C, $1E, $1E : DB $20, $20, $20, $22 : DB $22, $22, $24, $24 : DB $26, $26, $26, $28
	DB $1C, $1C, $1E, $1E : DB $20, $20, $22, $22 : DB $24, $24, $24, $26 : DB $26, $28, $28, $2A
	DB $1C, $1E, $1E, $20 : DB $20, $22, $22, $24 : DB $24, $26, $26, $28 : DB $28, $2A, $2A, $2C
	DB $1C, $1E, $1E, $20 : DB $20, $22, $22, $24 : DB $26, $26, $28, $28 : DB $2A, $2A, $2C, $2C
	DB $1C, $1E, $1E, $20 : DB $22, $22, $24, $24 : DB $26, $28, $28, $2A : DB $2C, $2C, $2E, $2E
	DB $1C, $1E, $1E, $20 : DB $22, $22, $24, $26 : DB $28, $28, $2A, $2C : DB $2C, $2E, $30, $30
	DB $1C, $1E, $20, $20 : DB $22, $24, $26, $26 : DB $28, $2A, $2C, $2C : DB $2E, $30, $32, $32
	DB $1C, $1E, $20, $20 : DB $22, $24, $26, $28 : DB $2A, $2A, $2C, $2E : DB $30, $32, $32, $34
	DB $1C, $1E, $20, $22 : DB $24, $24, $26, $28 : DB $2A, $2C, $2E, $30 : DB $32, $32, $34, $36
	DB $1C, $1E, $20, $22 : DB $24, $26, $28, $2A : DB $2C, $2C, $2E, $30 : DB $32, $34, $36, $38
	DB $1C, $1E, $20, $22 : DB $24, $26, $28, $2A : DB $2C, $2E, $30, $32 : DB $34, $36, $38, $3A
	DB $1C, $1E, $20, $22 : DB $24, $26, $28, $2A : DB $2E, $30, $32, $34 : DB $36, $38, $3A, $3C

TransitionSource0F:
	DB $1E, $1E, $1E, $1E : DB $1E, $1E, $1E, $1E : DB $20, $20, $20, $20 : DB $20, $20, $20, $20
	DB $1E, $1E, $1E, $1E : DB $20, $20, $20, $20 : DB $20, $20, $20, $20 : DB $22, $22, $22, $22
	DB $1E, $1E, $1E, $20 : DB $20, $20, $20, $20 : DB $22, $22, $22, $22 : DB $22, $22, $24, $24
	DB $1E, $1E, $20, $20 : DB $20, $20, $22, $22 : DB $22, $22, $24, $24 : DB $24, $24, $26, $26
	DB $1E, $1E, $20, $20 : DB $20, $22, $22, $22 : DB $24, $24, $24, $24 : DB $26, $26, $26, $28
	DB $1E, $1E, $20, $20 : DB $22, $22, $22, $24 : DB $24, $24, $26, $26 : DB $28, $28, $28, $2A
	DB $1E, $1E, $20, $20 : DB $22, $22, $24, $24 : DB $26, $26, $26, $28 : DB $28, $2A, $2A, $2C
	DB $1E, $20, $20, $22 : DB $22, $24, $24, $26 : DB $26, $28, $28, $2A : DB $2A, $2C, $2C, $2E
	DB $1E, $20, $20, $22 : DB $22, $24, $24, $26 : DB $28, $28, $2A, $2A : DB $2C, $2C, $2E, $2E
	DB $1E, $20, $20, $22 : DB $24, $24, $26, $26 : DB $28, $2A, $2A, $2C : DB $2E, $2E, $30, $30
	DB $1E, $20, $20, $22 : DB $24, $24, $26, $28 : DB $2A, $2A, $2C, $2E : DB $2E, $30, $32, $32
	DB $1E, $20, $22, $22 : DB $24, $26, $28, $28 : DB $2A, $2C, $2E, $2E : DB $30, $32, $34, $34
	DB $1E, $20, $22, $22 : DB $24, $26, $28, $2A : DB $2C, $2C, $2E, $30 : DB $32, $34, $34, $36
	DB $1E, $20, $22, $24 : DB $26, $26, $28, $2A : DB $2C, $2E, $30, $32 : DB $34, $34, $36, $38
	DB $1E, $20, $22, $24 : DB $26, $28, $2A, $2C : DB $2E, $2E, $30, $32 : DB $34, $36, $38, $3A
	DB $1E, $20, $22, $24 : DB $26, $28, $2A, $2C : DB $2E, $30, $32, $34 : DB $36, $38, $3A, $3C

TransitionSource10:
	DB $20, $20, $20, $20 : DB $20, $20, $20, $20 : DB $22, $22, $22, $22 : DB $22, $22, $22, $22
	DB $20, $20, $20, $20 : DB $22, $22, $22, $22 : DB $22, $22, $22, $22 : DB $24, $24, $24, $24
	DB $20, $20, $20, $22 : DB $22, $22, $22, $22 : DB $24, $24, $24, $24 : DB $24, $24, $26, $26
	DB $20, $20, $22, $22 : DB $22, $22, $24, $24 : DB $24, $24, $26, $26 : DB $26, $26, $28, $28
	DB $20, $20, $22, $22 : DB $22, $24, $24, $24 : DB $26, $26, $26, $26 : DB $28, $28, $28, $2A
	DB $20, $20, $22, $22 : DB $24, $24, $24, $26 : DB $26, $26, $28, $28 : DB $2A, $2A, $2A, $2C
	DB $20, $20, $22, $22 : DB $24, $24, $26, $26 : DB $28, $28, $28, $2A : DB $2A, $2C, $2C, $2E
	DB $20, $22, $22, $24 : DB $24, $26, $26, $28 : DB $28, $2A, $2A, $2C : DB $2C, $2E, $2E, $30
	DB $20, $22, $22, $24 : DB $24, $26, $26, $28 : DB $2A, $2A, $2C, $2C : DB $2E, $2E, $30, $30
	DB $20, $22, $22, $24 : DB $26, $26, $28, $28 : DB $2A, $2C, $2C, $2E : DB $30, $30, $32, $32
	DB $20, $22, $22, $24 : DB $26, $26, $28, $2A : DB $2C, $2C, $2E, $30 : DB $30, $32, $34, $34
	DB $20, $22, $24, $24 : DB $26, $28, $2A, $2A : DB $2C, $2E, $30, $30 : DB $32, $34, $36, $36
	DB $20, $22, $24, $24 : DB $26, $28, $2A, $2C : DB $2E, $2E, $30, $32 : DB $34, $36, $36, $38
	DB $20, $22, $24, $26 : DB $28, $28, $2A, $2C : DB $2E, $30, $32, $34 : DB $36, $36, $38, $3A
	DB $20, $22, $24, $26 : DB $28, $2A, $2C, $2E : DB $30, $30, $32, $34 : DB $36, $38, $3A, $3C

TransitionSource11:
	DB $22, $22, $22, $22 : DB $22, $22, $22, $22 : DB $24, $24, $24, $24 : DB $24, $24, $24, $24
	DB $22, $22, $22, $22 : DB $24, $24, $24, $24 : DB $24, $24, $24, $24 : DB $26, $26, $26, $26
	DB $22, $22, $22, $24 : DB $24, $24, $24, $24 : DB $26, $26, $26, $26 : DB $26, $26, $28, $28
	DB $22, $22, $24, $24 : DB $24, $24, $26, $26 : DB $26, $26, $28, $28 : DB $28, $28, $2A, $2A
	DB $22, $22, $24, $24 : DB $24, $26, $26, $26 : DB $28, $28, $28, $28 : DB $2A, $2A, $2A, $2C
	DB $22, $22, $24, $24 : DB $26, $26, $26, $28 : DB $28, $28, $2A, $2A : DB $2C, $2C, $2C, $2E
	DB $22, $22, $24, $24 : DB $26, $26, $28, $28 : DB $2A, $2A, $2A, $2C : DB $2C, $2E, $2E, $30
	DB $22, $24, $24, $26 : DB $26, $28, $28, $2A : DB $2A, $2C, $2C, $2E : DB $2E, $30, $30, $32
	DB $22, $24, $24, $26 : DB $26, $28, $28, $2A : DB $2C, $2C, $2E, $2E : DB $30, $30, $32, $32
	DB $22, $24, $24, $26 : DB $28, $28, $2A, $2A : DB $2C, $2E, $2E, $30 : DB $32, $32, $34, $34
	DB $22, $24, $24, $26 : DB $28, $28, $2A, $2C : DB $2E, $2E, $30, $32 : DB $32, $34, $36, $36
	DB $22, $24, $26, $26 : DB $28, $2A, $2C, $2C : DB $2E, $30, $32, $32 : DB $34, $36, $38, $38
	DB $22, $24, $26, $26 : DB $28, $2A, $2C, $2E : DB $30, $30, $32, $34 : DB $36, $38, $38, $3A
	DB $22, $24, $26, $28 : DB $2A, $2A, $2C, $2E : DB $30, $32, $34, $36 : DB $38, $38, $3A, $3C

TransitionSource12:
	DB $24, $24, $24, $24 : DB $24, $24, $24, $24 : DB $26, $26, $26, $26 : DB $26, $26, $26, $26
	DB $24, $24, $24, $24 : DB $26, $26, $26, $26 : DB $26, $26, $26, $26 : DB $28, $28, $28, $28
	DB $24, $24, $24, $26 : DB $26, $26, $26, $26 : DB $28, $28, $28, $28 : DB $28, $28, $2A, $2A
	DB $24, $24, $26, $26 : DB $26, $26, $28, $28 : DB $28, $28, $2A, $2A : DB $2A, $2A, $2C, $2C
	DB $24, $24, $26, $26 : DB $26, $28, $28, $28 : DB $2A, $2A, $2A, $2A : DB $2C, $2C, $2C, $2E
	DB $24, $24, $26, $26 : DB $28, $28, $28, $2A : DB $2A, $2A, $2C, $2C : DB $2E, $2E, $2E, $30
	DB $24, $24, $26, $26 : DB $28, $28, $2A, $2A : DB $2C, $2C, $2C, $2E : DB $2E, $30, $30, $32
	DB $24, $26, $26, $28 : DB $28, $2A, $2A, $2C : DB $2C, $2E, $2E, $30 : DB $30, $32, $32, $34
	DB $24, $26, $26, $28 : DB $28, $2A, $2A, $2C : DB $2E, $2E, $30, $30 : DB $32, $32, $34, $34
	DB $24, $26, $26, $28 : DB $2A, $2A, $2C, $2C : DB $2E, $30, $30, $32 : DB $34, $34, $36, $36
	DB $24, $26, $26, $28 : DB $2A, $2A, $2C, $2E : DB $30, $30, $32, $34 : DB $34, $36, $38, $38
	DB $24, $26, $28, $28 : DB $2A, $2C, $2E, $2E : DB $30, $32, $34, $34 : DB $36, $38, $3A, $3A
	DB $24, $26, $28, $28 : DB $2A, $2C, $2E, $30 : DB $32, $32, $34, $36 : DB $38, $3A, $3A, $3C

TransitionSource13:
	DB $26, $26, $26, $26 : DB $26, $26, $26, $26 : DB $28, $28, $28, $28 : DB $28, $28, $28, $28
	DB $26, $26, $26, $26 : DB $28, $28, $28, $28 : DB $28, $28, $28, $28 : DB $2A, $2A, $2A, $2A
	DB $26, $26, $26, $28 : DB $28, $28, $28, $28 : DB $2A, $2A, $2A, $2A : DB $2A, $2A, $2C, $2C
	DB $26, $26, $28, $28 : DB $28, $28, $2A, $2A : DB $2A, $2A, $2C, $2C : DB $2C, $2C, $2E, $2E
	DB $26, $26, $28, $28 : DB $28, $2A, $2A, $2A : DB $2C, $2C, $2C, $2C : DB $2E, $2E, $2E, $30
	DB $26, $26, $28, $28 : DB $2A, $2A, $2A, $2C : DB $2C, $2C, $2E, $2E : DB $30, $30, $30, $32
	DB $26, $26, $28, $28 : DB $2A, $2A, $2C, $2C : DB $2E, $2E, $2E, $30 : DB $30, $32, $32, $34
	DB $26, $28, $28, $2A : DB $2A, $2C, $2C, $2E : DB $2E, $30, $30, $32 : DB $32, $34, $34, $36
	DB $26, $28, $28, $2A : DB $2A, $2C, $2C, $2E : DB $30, $30, $32, $32 : DB $34, $34, $36, $36
	DB $26, $28, $28, $2A : DB $2C, $2C, $2E, $2E : DB $30, $32, $32, $34 : DB $36, $36, $38, $38
	DB $26, $28, $28, $2A : DB $2C, $2C, $2E, $30 : DB $32, $32, $34, $36 : DB $36, $38, $3A, $3A
	DB $26, $28, $2A, $2A : DB $2C, $2E, $30, $30 : DB $32, $34, $36, $36 : DB $38, $3A, $3C, $3C

TransitionSource14:
	DB $28, $28, $28, $28 : DB $28, $28, $28, $28 : DB $2A, $2A, $2A, $2A : DB $2A, $2A, $2A, $2A
	DB $28, $28, $28, $28 : DB $2A, $2A, $2A, $2A : DB $2A, $2A, $2A, $2A : DB $2C, $2C, $2C, $2C
	DB $28, $28, $28, $2A : DB $2A, $2A, $2A, $2A : DB $2C, $2C, $2C, $2C : DB $2C, $2C, $2E, $2E
	DB $28, $28, $2A, $2A : DB $2A, $2A, $2C, $2C : DB $2C, $2C, $2E, $2E : DB $2E, $2E, $30, $30
	DB $28, $28, $2A, $2A : DB $2A, $2C, $2C, $2C : DB $2E, $2E, $2E, $2E : DB $30, $30, $30, $32
	DB $28, $28, $2A, $2A : DB $2C, $2C, $2C, $2E : DB $2E, $2E, $30, $30 : DB $32, $32, $32, $34
	DB $28, $28, $2A, $2A : DB $2C, $2C, $2E, $2E : DB $30, $30, $30, $32 : DB $32, $34, $34, $36
	DB $28, $2A, $2A, $2C : DB $2C, $2E, $2E, $30 : DB $30, $32, $32, $34 : DB $34, $36, $36, $38
	DB $28, $2A, $2A, $2C : DB $2C, $2E, $2E, $30 : DB $32, $32, $34, $34 : DB $36, $36, $38, $38
	DB $28, $2A, $2A, $2C : DB $2E, $2E, $30, $30 : DB $32, $34, $34, $36 : DB $38, $38, $3A, $3A
	DB $28, $2A, $2A, $2C : DB $2E, $2E, $30, $32 : DB $34, $34, $36, $38 : DB $38, $3A, $3C, $3C

TransitionSource15:
	DB $2A, $2A, $2A, $2A : DB $2A, $2A, $2A, $2A : DB $2C, $2C, $2C, $2C : DB $2C, $2C, $2C, $2C
	DB $2A, $2A, $2A, $2A : DB $2C, $2C, $2C, $2C : DB $2C, $2C, $2C, $2C : DB $2E, $2E, $2E, $2E
	DB $2A, $2A, $2A, $2C : DB $2C, $2C, $2C, $2C : DB $2E, $2E, $2E, $2E : DB $2E, $2E, $30, $30
	DB $2A, $2A, $2C, $2C : DB $2C, $2C, $2E, $2E : DB $2E, $2E, $30, $30 : DB $30, $30, $32, $32
	DB $2A, $2A, $2C, $2C : DB $2C, $2E, $2E, $2E : DB $30, $30, $30, $30 : DB $32, $32, $32, $34
	DB $2A, $2A, $2C, $2C : DB $2E, $2E, $2E, $30 : DB $30, $30, $32, $32 : DB $34, $34, $34, $36
	DB $2A, $2A, $2C, $2C : DB $2E, $2E, $30, $30 : DB $32, $32, $32, $34 : DB $34, $36, $36, $38
	DB $2A, $2C, $2C, $2E : DB $2E, $30, $30, $32 : DB $32, $34, $34, $36 : DB $36, $38, $38, $3A
	DB $2A, $2C, $2C, $2E : DB $2E, $30, $30, $32 : DB $34, $34, $36, $36 : DB $38, $38, $3A, $3A
	DB $2A, $2C, $2C, $2E : DB $30, $30, $32, $32 : DB $34, $36, $36, $38 : DB $3A, $3A, $3C, $3C

TransitionSource16:
	DB $2C, $2C, $2C, $2C : DB $2C, $2C, $2C, $2C : DB $2E, $2E, $2E, $2E : DB $2E, $2E, $2E, $2E
	DB $2C, $2C, $2C, $2C : DB $2E, $2E, $2E, $2E : DB $2E, $2E, $2E, $2E : DB $30, $30, $30, $30
	DB $2C, $2C, $2C, $2E : DB $2E, $2E, $2E, $2E : DB $30, $30, $30, $30 : DB $30, $30, $32, $32
	DB $2C, $2C, $2E, $2E : DB $2E, $2E, $30, $30 : DB $30, $30, $32, $32 : DB $32, $32, $34, $34
	DB $2C, $2C, $2E, $2E : DB $2E, $30, $30, $30 : DB $32, $32, $32, $32 : DB $34, $34, $34, $36
	DB $2C, $2C, $2E, $2E : DB $30, $30, $30, $32 : DB $32, $32, $34, $34 : DB $36, $36, $36, $38
	DB $2C, $2C, $2E, $2E : DB $30, $30, $32, $32 : DB $34, $34, $34, $36 : DB $36, $38, $38, $3A
	DB $2C, $2E, $2E, $30 : DB $30, $32, $32, $34 : DB $34, $36, $36, $38 : DB $38, $3A, $3A, $3C
	DB $2C, $2E, $2E, $30 : DB $30, $32, $32, $34 : DB $36, $36, $38, $38 : DB $3A, $3A, $3C, $3C

TransitionSource17:
	DB $2E, $2E, $2E, $2E : DB $2E, $2E, $2E, $2E : DB $30, $30, $30, $30 : DB $30, $30, $30, $30
	DB $2E, $2E, $2E, $2E : DB $30, $30, $30, $30 : DB $30, $30, $30, $30 : DB $32, $32, $32, $32
	DB $2E, $2E, $2E, $30 : DB $30, $30, $30, $30 : DB $32, $32, $32, $32 : DB $32, $32, $34, $34
	DB $2E, $2E, $30, $30 : DB $30, $30, $32, $32 : DB $32, $32, $34, $34 : DB $34, $34, $36, $36
	DB $2E, $2E, $30, $30 : DB $30, $32, $32, $32 : DB $34, $34, $34, $34 : DB $36, $36, $36, $38
	DB $2E, $2E, $30, $30 : DB $32, $32, $32, $34 : DB $34, $34, $36, $36 : DB $38, $38, $38, $3A
	DB $2E, $2E, $30, $30 : DB $32, $32, $34, $34 : DB $36, $36, $36, $38 : DB $38, $3A, $3A, $3C
	DB $2E, $30, $30, $32 : DB $32, $34, $34, $36 : DB $36, $38, $38, $3A : DB $3A, $3C, $3C, $3E

TransitionSource18:
	DB $30, $30, $30, $30 : DB $30, $30, $30, $30 : DB $32, $32, $32, $32 : DB $32, $32, $32, $32
	DB $30, $30, $30, $30 : DB $32, $32, $32, $32 : DB $32, $32, $32, $32 : DB $34, $34, $34, $34
	DB $30, $30, $30, $32 : DB $32, $32, $32, $32 : DB $34, $34, $34, $34 : DB $34, $34, $36, $36
	DB $30, $30, $32, $32 : DB $32, $32, $34, $34 : DB $34, $34, $36, $36 : DB $36, $36, $38, $38
	DB $30, $30, $32, $32 : DB $32, $34, $34, $34 : DB $36, $36, $36, $36 : DB $38, $38, $38, $3A
	DB $30, $30, $32, $32 : DB $34, $34, $34, $36 : DB $36, $36, $38, $38 : DB $3A, $3A, $3A, $3C
	DB $30, $30, $32, $32 : DB $34, $34, $36, $36 : DB $38, $38, $38, $3A : DB $3A, $3C, $3C, $3E

TransitionSource19:
	DB $32, $32, $32, $32 : DB $32, $32, $32, $32 : DB $34, $34, $34, $34 : DB $34, $34, $34, $34
	DB $32, $32, $32, $32 : DB $34, $34, $34, $34 : DB $34, $34, $34, $34 : DB $36, $36, $36, $36
	DB $32, $32, $32, $34 : DB $34, $34, $34, $34 : DB $36, $36, $36, $36 : DB $36, $36, $38, $38
	DB $32, $32, $34, $34 : DB $34, $34, $36, $36 : DB $36, $36, $38, $38 : DB $38, $38, $3A, $3A
	DB $32, $32, $34, $34 : DB $34, $36, $36, $36 : DB $38, $38, $38, $38 : DB $3A, $3A, $3A, $3C
	DB $32, $32, $34, $34 : DB $36, $36, $36, $38 : DB $38, $38, $3A, $3A : DB $3C, $3C, $3C, $3E

TransitionSource1A:
	DB $34, $34, $34, $34 : DB $34, $34, $34, $34 : DB $36, $36, $36, $36 : DB $36, $36, $36, $36
	DB $34, $34, $34, $34 : DB $36, $36, $36, $36 : DB $36, $36, $36, $36 : DB $38, $38, $38, $38
	DB $34, $34, $34, $36 : DB $36, $36, $36, $36 : DB $38, $38, $38, $38 : DB $38, $38, $3A, $3A
	DB $34, $34, $36, $36 : DB $36, $36, $38, $38 : DB $38, $38, $3A, $3A : DB $3A, $3A, $3C, $3C
	DB $34, $34, $36, $36 : DB $36, $38, $38, $38 : DB $3A, $3A, $3A, $3A : DB $3C, $3C, $3C, $3E

TransitionSource1B:
	DB $36, $36, $36, $36 : DB $36, $36, $36, $36 : DB $38, $38, $38, $38 : DB $38, $38, $38, $38
	DB $36, $36, $36, $36 : DB $38, $38, $38, $38 : DB $38, $38, $38, $38 : DB $3A, $3A, $3A, $3A
	DB $36, $36, $36, $38 : DB $38, $38, $38, $38 : DB $3A, $3A, $3A, $3A : DB $3A, $3A, $3C, $3C
	DB $36, $36, $38, $38 : DB $38, $38, $3A, $3A : DB $3A, $3A, $3C, $3C : DB $3C, $3C, $3E, $3E

TransitionSource1C:
	DB $38, $38, $38, $38 : DB $38, $38, $38, $38 : DB $3A, $3A, $3A, $3A : DB $3A, $3A, $3A, $3A
	DB $38, $38, $38, $38 : DB $3A, $3A, $3A, $3A : DB $3A, $3A, $3A, $3A : DB $3C, $3C, $3C, $3C
	DB $38, $38, $38, $3A : DB $3A, $3A, $3A, $3A : DB $3C, $3C, $3C, $3C : DB $3C, $3C, $3E, $3E

TransitionSource1D:
	DB $3A, $3A, $3A, $3A : DB $3A, $3A, $3A, $3A : DB $3C, $3C, $3C, $3C : DB $3C, $3C, $3C, $3C
	DB $3A, $3A, $3A, $3A : DB $3C, $3C, $3C, $3C : DB $3C, $3C, $3C, $3C : DB $3E, $3E, $3E, $3E

TransitionSource1E:
	DB $3C, $3C, $3C, $3C : DB $3C, $3C, $3C, $3C : DB $3E, $3E, $3E, $3E : DB $3E, $3E, $3E, $3E

}
;---------------------------------------------------------------------------------------------------
;|x|									BANK $??		Arm cannon palette						 |x|
;---------------------------------------------------------------------------------------------------
{ ORG !BankCannonPalette		;Just storage for arm cannon palette
;"Metroid" cannon palette
Cannon_N_00: DW $1104, $21A8, $3A4E, $4AD2	;(04,08,04),(08,0D,08),(0E,12,0E),(12,16,12)	Default
Cannon_N_04: DW $3900, $51A2, $7285, $7F0A	;(00,08,0E),(02,0D,14),(05,14,1C),(0A,18,1F)	MF Ice
Cannon_N_06: DW $348D, $4912, $6DDB, $7E5F	;(0D,04,0D),(12,08,12),(1B,0E,1B),(1F,12,1F)	MF Wave
Cannon_N_08: DW $0108, $1252, $237B, $3BFF	;(08,08,00),(12,12,04),(1B,1B,08),(1F,1F,0E)	MF Spazer
Cannon_N_0A: DW $1140, $19C0, $2280, $2B40	;(00,0A,04),(00,0E,06),(00,14,08),(00,1A,0A)	MF Plasma
Cannon_N_0E: DW $38A0, $4560, $6E40, $7EC0	;(00,05,0E),(00,0B,11),(00,12,1B),(00,16,1F)	PB Ice
Cannon_N_10: DW $0809, $0457, $24BF, $399F	;(09,00,02),(17,02,01),(1F,05,09),(1F,0C,0E)	PB Wave
Cannon_N_12: DW $00C8, $0190, $025A, $02DF	;(08,06,00),(10,0C,00),(1A,12,00),(1F,16,00)	PB Spazer
Cannon_N_14: DW $0100, $01A0, $0260, $0320	;(00,08,00),(00,0D,00),(00,13,00),(00,19,00)	PB Plasma

;"Gems" cannon palette
Cannon_G_16: DW $0014, $0017, $005C, $005F	;(14,00,00),(17,00,00),(1C,02,00),(1F,02,00)	Ruby
Cannon_G_18: DW $36CD, $4314, $23B9, $43DB	;(10,1E,10),(19,1D,08),(14,18,10),(0D,16,0D)	Peridot
Cannon_G_1A: DW $4463, $5525, $5D89, $720B	;(03,03,11),(05,09,15),(09,0C,17),(0B,10,1C)	Sapphire
Cannon_G_1C: DW $2475, $499F, $66FF, $7F7F	;(15,03,09),(1F,0C,12),(1F,17,19),(1F,1B,1F)	Tourmaline
Cannon_G_1E: DW $010E, $01F8, $1AFC, $1F9F	;(0E,08,00),(18,0F,00),(1C,17,06),(1F,1C,07)	Citrine
Cannon_G_20: DW $51A8, $76AC, $7F31, $7F73	;(08,0D,14),(11,19,1D),(11,19,1F),(13,1B,1F)	Zircon
Cannon_G_22: DW $0008, $010E, $0132, $0156	;(08,00,00),(0E,08,00),(12,09,00),(16,0A,00)	Garnet
Cannon_G_24: DW $504F, $6912, $7E19, $7F3E	;(0F,02,14),(12,08,1A),(19,10,1F),(1E,19,1F)	Amethyst
Cannon_G_26: DW $5640, $7FB5, $7FF8, $7FFC	;(00,12,15),(15,1D,1F),(18,1F,1F),(1C,1F,1F)	Aquamarine
Cannon_G_28: DW $6B38, $6B7A, $7FDF, $7FFF	;(18,19,1A),(1A,1B,1A),(1F,1E,1F),(1F,1F,1F)	Diamond
Cannon_G_2A: DW $0580, $1680, $2AC0, $4729	;(00,0C,01),(00,14,05),(00,16,0A),(09,19,11)	Emerald
Cannon_G_2C: DW $3072, $40BA, $617E, $6A3E	;(12,03,0C),(1A,05,10),(1E,0B,18),(1E,11,1A)	Alexandrite
Cannon_G_2E: DW $208C, $2096, $249A, $309F	;(0C,04,08),(16,04,08),(1A,04,08),(1F,04,0C)	Rhodolite
Cannon_G_30: DW $0000, $1084, $2529, $4210	;(00,00,00),(04,04,04),(09,09,09),(10,10,10)	Onyx
Cannon_G_32: DW $18A6, $4A32, $6719, $7FDF	;(06,05,06),(12,11,12),(19,18,19),(1F,1E,1F)	Opal
Cannon_G_34: DW $08D7, $11BB, $1AFC, $1F7F	;(17,06,02),(1B,0D,04),(1C,17,06),(1F,1B,07)	Topaz

;"Metal" cannon palette
Cannon_M_36: DW $254B, $35CF, $4A74, $5AF8	;(0B,0A,09),(0F,0E,0D),(14,13,12),(18,17,16)	Iron
Cannon_M_38: DW $1511, $2197, $2A1C, $369F	;(11,08,05),(17,0C,08),(1C,10,0A),(1F,14,0D)	Copper
Cannon_M_3A: DW $0974, $11F9, $2EBF, $439F	;(14,0B,02),(19,0F,04),(1F,15,0B),(1F,1C,10)	Bronze
Cannon_M_3C: DW $1E36, $2AFB, $375D, $3F9E	;(16,11,07),(1B,17,0A),(1D,1A,0D),(1E,1C,0F)	Gold
Cannon_M_3E: DW $4210, $5294, $6318, $739C	;(10,10,10),(14,14,14),(18,18,18),(1C,1C,1C)	Aluminum
Cannon_M_40: DW $0C63, $14A5, $2108, $318C	;(03,03,03),(05,05,05),(08,08,08),(0C,0C,0C)	Graphite
Cannon_M_42: DW $294A, $4210, $5EF7, $7BDE	;(0A,0A,0A),(10,10,10),(17,17,17),(1E,1E,1E)	Steel
Cannon_M_44: DW $042B, $042E, $0851, $0854	;(0B,02,02),(0E,03,03),(11,02,02),(14,02,02)	Red Steel
Cannon_M_46: DW $09C8, $124A, $16AC, $1B0E	;(08,0E,02),(0A,12,04),(0C,15,05),(0E,18,06)	Green Steel
Cannon_M_48: DW $5542, $5DA4, $6606, $6E48	;(02,0A,15),(04,0D,17),(06,10,19),(08,12,1B)	Blue Steel

;"Mixed" cannon palette
Cannon_X_4A: DW $0856, $1198, $1A5A, $239C	;(16,02,02),(18,0C,04),(1A,12,06),(1C,1C,08)	Flame
Cannon_X_4C: DW $0AC2, $130C, $1B52, $239C	;(02,16,02),(0C,18,04),(12,1A,06),(1C,1C,08)	Green Flame
Cannon_X_4E: DW $5842, $6184, $6A46, $7388	;(02,02,16),(04,0C,18),(08,12,1A),(08,1C,1C)	Blue Flame
Cannon_X_50: DW $0ACA, $12D0, $1AD6, $22DC	;(0A,16,02),(10,16,04),(16,16,06),(1C,16,08)	Yellow Gradient
Cannon_X_52: DW $2AC2, $42C4, $5AC6, $72C8	;(02,16,0A),(04,16,10),(06,16,16),(08,16,1C)	Cyan Gradient
Cannon_X_54: DW $2856, $4096, $58D6, $7116	;(16,02,0A),(16,04,10),(16,06,16),(16,08,1C)	Violet Gradient
Cannon_X_56: DW $58C0, $5960, $5A00, $5AC0	;(00,06,16),(00,0B,16),(00,10,16),(00,16,16)	Ocean
Cannon_X_58: DW $300C, $3CE8, $4DE4, $5AC0	;(0C,00,0C),(08,07,0F),(04,0F,13),(00,16,16)	Midnight
Cannon_X_5A: DW $0200, $0300, $03E0, $43F0	;(00,10,00),(00,18,00),(00,1F,00),(10,1F,10)	Nuclear
Cannon_X_5C: DW $6018, $609A, $611C, $619E	;(18,00,18),(1A,04,18),(1C,08,18),(1E,0C,18)	Love
Cannon_X_5E: DW $0318, $2B5A, $539C, $7BDE	;(18,18,00),(1A,1A,0A),(1C,1C,14),(1E,1E,1E)	Bliss
Cannon_X_60: DW $1004, $2008, $380E, $4812	;(04,00,04),(08,00,08),(0E,00,0E),(12,00,12)	Void

;"Miscellaneous" cannon palette
Cannon_A_62: DW $6988, $5A37, $7F14, $5B3C	;(0B,0C,1A),(17,11,16),(14,18,1F),(1C,19,16)	Case Hardened
Cannon_A_64: DW $0000, $0000, $7FFF, $7FFF	;(00,00,00),(00,00,00),(1F,1F,1F),(1F,1F,1F)	Black N White
Cannon_A_66: DW $1908, $2DAD, $4252, $4AD6	;(08,08,06),(0D,0D,08),(12,12,10),(16,16,14)	Cinematic
Cannon_A_68: DW $6EFB, $5E57, $45B1, $352D	;(1B,17,1B),(17,12,17),(11,0D,11),(0D,09,0D)	Inverted
}
;---------------------------------------------------------------------------------------------------
;|x|									BANK $84		Update palette after item pickup		 |x|
;---------------------------------------------------------------------------------------------------

ORG $8488D8 : JSL UpdatePaletterAfterItemPickup

;---------------------------------------------------------------------------------------------------
;|x|									BANK $8D		FX										 |x|
;---------------------------------------------------------------------------------------------------
{ ;---doesn't need freespace, uses space of code which is unused---
;---this bank will be used when samus is in heated area or loads from save station---
ORG $8DA9C5 : PADBYTE $FF : PAD $8DAAB9			;delete "unused data"
ORG $8DA9C5
LoadStation3:
	LDA #$0006 : BRA LoadStationBranch			;set index and run cannon palette routine
LoadStation2:
	LDA #$0004 : BRA LoadStationBranch
LoadStation1:
	LDA #$0002 : BRA LoadStationBranch
LoadStationDefault:
	LDA #$0000
LoadStationBranch:
	LDX $0A76 : BNE + : JSL LoadStationSetup	;skip arm cannon palette overwrite when loading game, if hyper beam is active
+ : JMP $C595									;(idk if this branch will ever be used, but if you want to save and load the game with hyper beam, it's there)
FXHeatGlow:
	LDA $0A76 : BNE + : JSL FXHeatGlowSetup		;skip arm cannon palette overwrite in heated areas, if hyper beam is active
+ : JMP $C595
	

;Samus loading - power suit
ORG $8DDB8B : DW LoadStationDefault
ORG $8DDBAF : DW LoadStation3
ORG $8DDBDA : DW LoadStationDefault
ORG $8DDBFE : DW LoadStation3
ORG $8DDC29 : DW LoadStationDefault
ORG $8DDC4D : DW LoadStation2
ORG $8DDC78 : DW LoadStationDefault
ORG $8DDC9C : DW LoadStation1
ORG $8DDCC4 : DW LoadStationDefault

;Samus loading - varia suit
ORG $8DDCF1 : DW LoadStationDefault
ORG $8DDD15 : DW LoadStation3
ORG $8DDD40 : DW LoadStationDefault
ORG $8DDD64 : DW LoadStation3
ORG $8DDD8F : DW LoadStationDefault
ORG $8DDDB3 : DW LoadStation2
ORG $8DDDDE : DW LoadStationDefault
ORG $8DDE02 : DW LoadStation1
ORG $8DDE2A : DW LoadStationDefault

;Samus loading - gravity suit
ORG $8DDE57 : DW LoadStationDefault
ORG $8DDE7B : DW LoadStation3
ORG $8DDEA6 : DW LoadStationDefault
ORG $8DDECA : DW LoadStation3
ORG $8DDEF5 : DW LoadStationDefault
ORG $8DDF19 : DW LoadStation2
ORG $8DDF44 : DW LoadStationDefault
ORG $8DDF68 : DW LoadStation1
ORG $8DDF90 : DW LoadStationDefault


;Samus in heat - power suit
ORG $8DE486 : DW FXHeatGlow
ORG $8DE4A8 : DW FXHeatGlow
ORG $8DE4CA : DW FXHeatGlow
ORG $8DE4EC : DW FXHeatGlow
ORG $8DE50E : DW FXHeatGlow
ORG $8DE530 : DW FXHeatGlow
ORG $8DE552 : DW FXHeatGlow
ORG $8DE574 : DW FXHeatGlow
ORG $8DE596 : DW FXHeatGlow
ORG $8DE5B8 : DW FXHeatGlow
ORG $8DE5DA : DW FXHeatGlow
ORG $8DE5FC : DW FXHeatGlow
ORG $8DE61E : DW FXHeatGlow
ORG $8DE640 : DW FXHeatGlow
ORG $8DE662 : DW FXHeatGlow
ORG $8DE684 : DW FXHeatGlow

;Samus in heat - varia suit
ORG $8DE6B2 : DW FXHeatGlow
ORG $8DE6D4 : DW FXHeatGlow
ORG $8DE6F6 : DW FXHeatGlow
ORG $8DE718 : DW FXHeatGlow
ORG $8DE73A : DW FXHeatGlow
ORG $8DE75C : DW FXHeatGlow
ORG $8DE77E : DW FXHeatGlow
ORG $8DE7A0 : DW FXHeatGlow
ORG $8DE7C2 : DW FXHeatGlow
ORG $8DE7E4 : DW FXHeatGlow
ORG $8DE806 : DW FXHeatGlow
ORG $8DE828 : DW FXHeatGlow
ORG $8DE84A : DW FXHeatGlow
ORG $8DE86C : DW FXHeatGlow
ORG $8DE88E : DW FXHeatGlow
ORG $8DE8B0 : DW FXHeatGlow

;Samus in heat - gravity suit
ORG $8DE8DE : DW FXHeatGlow
ORG $8DE900 : DW FXHeatGlow
ORG $8DE922 : DW FXHeatGlow
ORG $8DE944 : DW FXHeatGlow
ORG $8DE966 : DW FXHeatGlow
ORG $8DE988 : DW FXHeatGlow
ORG $8DE9AA : DW FXHeatGlow
ORG $8DE9CC : DW FXHeatGlow
ORG $8DE9EE : DW FXHeatGlow
ORG $8DEA10 : DW FXHeatGlow
ORG $8DEA32 : DW FXHeatGlow
ORG $8DEA54 : DW FXHeatGlow
ORG $8DEA76 : DW FXHeatGlow
ORG $8DEA98 : DW FXHeatGlow
ORG $8DEABA : DW FXHeatGlow
ORG $8DEADC : DW FXHeatGlow
}
;---------------------------------------------------------------------------------------------------
;|x|									BANK $90		Beam palettes							 |x|
;---------------------------------------------------------------------------------------------------
{
ORG $90ACCD : LDA.w #!BankBeamPalettes/$10000
ORG $90ACD3 : JSR BeamColor
ORG $90AD01 : LDA.w #!BankBeamPalettes/$10000
ORG $90AD07 : JSR BeamColor

ORG $90B58F
	DW $0004, $2C3C		;Changing wave beam trail pal number to beams
	DW $0004, $2C3D		;Else it would use the pal number for energy drops
	DW $0004, $2C3E
	DW $0004, $2C3F

;set beam glow characteristics for normal shots, if charge is equipped
ORG $90B968 : JSL BeamGlowDurationNormalShot
;beam glow characteristics for charged shots
ORG $90BA36 : LDA.w #!BeamGlowFixedBitCharged*$40+!BeamGlowFixedTransitionCharged*$100+!BeamGlowDurationCharged+$8000

ORG $90C3C9
	DW Beam_M_Power_, Beam_M_Wave__, Beam_M_Ice___, Beam_M_Ice___
	DW Beam_M_Spazer, Beam_M_Wave__, Beam_M_Ice___, Beam_M_Ice___
	DW Beam_M_Plasma, Beam_M_Plasma, Beam_M_Ice___, Beam_M_Ice___
	DW Beam_M_Plasma, Beam_M_Plasma, Beam_M_Ice___, Beam_M_Ice___

BeamColor:
	LDA !ApplyColorToBeams : BEQ ++
	LDX !CannonPalette : LDA.w BeamColorPalettePointer,x : BEQ ++ : RTS
++ : LDA $C3C9,y : RTS

BeamColorPalettePointer:
	;"Metroid" beam palette
	DW Beam_M_Power_, $0000, Beam_M_Ice___, Beam_M_Wave__
	DW Beam_M_Spazer, Beam_M_Plasma, $0000, Beam_M_Ice___
	DW Beam_M_Wave__, Beam_M_Spazer, Beam_M_Plasma
	;"Gems" beam palette
	DW Beam_G_16, Beam_G_18, Beam_G_1A, Beam_G_1C
	DW Beam_G_1E, Beam_G_20, Beam_G_22, Beam_G_24
	DW Beam_G_26, Beam_G_28, Beam_G_2A, Beam_G_2C
	DW Beam_G_2E, Beam_G_30, Beam_G_32, Beam_G_34
	;"Metal" beam palette
	DW Beam_M_36, Beam_M_38, Beam_M_3A, Beam_M_3C
	DW Beam_M_3E, Beam_M_40, Beam_M_42, Beam_M_44
	DW Beam_M_46, Beam_M_48
	;"Mixed" beam palette
	DW Beam_X_4A, Beam_X_4C, Beam_X_4E, Beam_X_50
	DW Beam_X_52, Beam_X_54, Beam_X_56, Beam_X_58
	DW Beam_X_5A, Beam_X_5C, Beam_X_5E, Beam_X_60
	;"Miscellaneous" beam palette
	DW Beam_A_62, Beam_A_64, Beam_A_66, Beam_A_68
PADBYTE $FF : PAD $90C481		;delete original "beam palette sets"


ORG !BankBeamPalettes
;"Metroid" beam palette (vanilla)
Beam_M_Power_: DW $3800, $7FFF, $19FF, $1D55, $10AD, $53FF, $039E, $295F, $18DF, $6B90, $6B50, $630E, $4A4E, $420E, $6BD8, $104A
Beam_M_Ice___: DW $3800, $7FFF, $7EC0, $6DE0, $54E0, $7F6E, $730A, $6665, $5E22, $7FA0, $7B60, $7720, $72A0, $6E60, $7F91, $20C0
Beam_M_Wave__: DW $3800, $7FFF, $7C1F, $5816, $300C, $7EDF, $7DDF, $7CDF, $681A, $7F8F, $7B0F, $76AE, $71AE, $6D2D, $7F58, $2409
Beam_M_Plasma: DW $3800, $7FFF, $3BE0, $2680, $1580, $6BFA, $4BF2, $2BEA, $03E0, $7BCD, $738A, $6B68, $5B02, $52E0, $77D6, $0920
Beam_M_Spazer: DW $3800, $7FFF, $03FF, $0216, $00EE, $6BFF, $4BFF, $2BFF, $037B, $73D0, $6B8F, $5B6E, $430E, $3AEE, $77D8, $00AD

;"Gems" beam palette
Beam_G_16: DW $3800, $7FFF, $001F, $0016, $000C, $5ADF, $39DF, $18DF, $001B, $7390, $6B0F, $5A8E, $41AE, $394E, $7358, $0009
Beam_G_18: DW $3800, $7FFF, $03EF, $02CB, $0186, $5BFA, $3BF2, $1BEA, $0340, $73CE, $6B8C, $5B6B, $4308, $3AE6, $73D6, $0120
Beam_G_1A: DW $3800, $7FFF, $7DE0, $5960, $30C0, $7F56, $7E4E, $7D46, $6C00, $7F8D, $7B4A, $7708, $7242, $6E00, $7F94, $2400
Beam_G_1C: DW $3800, $7FFF, $3C1F, $2C16, $180C, $6ADF, $49DF, $28DF, $001B, $7F90, $730F, $6A8E, $59AE, $514E, $7758, $0009
Beam_G_1E: DW $3800, $7FFF, $03FF, $0216, $00EE, $6BFF, $4BFF, $2BFF, $037B, $73D0, $6B8F, $5B6E, $430E, $3AEE, $77D8, $00AD
Beam_G_20: DW $3800, $7FFF, $7F10, $5A0B, $3126, $7F9A, $7F32, $7EAA, $6DC0, $7FAD, $7B6A, $772A, $72C8, $6E86, $7F96, $2520
Beam_G_22: DW $3800, $7FFF, $0196, $00CC, $0006, $0176, $00EE, $0066, $0000, $438E, $3F4E, $3ACC, $3A2A, $39CA, $42B4, $0000
Beam_G_24: DW $3800, $7FFF, $7C18, $5811, $3009, $7EDD, $7DDA, $7CD9, $6C15, $7F8E, $7B0E, $768C, $71AC, $6D4A, $7F57, $2409
Beam_G_26: DW $3800, $7FFF, $7FE0, $5AC0, $3180, $7FF6, $7FEE, $7FE6, $6F60, $7FCD, $7B8A, $7708, $7302, $6EE0, $7FD4, $2520
Beam_G_28: DW $3800, $7FFF, $7FDD, $5AB4, $316A, $7FDD, $779B, $6F59, $6717, $7FCE, $7B8E, $774E, $730D, $6ECC, $7FB7, $2507
Beam_G_2A: DW $3800, $7FFF, $03E0, $02C0, $0180, $5BF6, $3BEE, $1BE6, $0360, $73CD, $6B8A, $5B68, $4302, $3AE0, $73D4, $0120
Beam_G_2C: DW $3800, $7FFF, $601F, $4016, $240C, $62DF, $61DF, $60DF, $541B, $7B90, $730F, $6E8E, $69AE, $614E, $7358, $1809
Beam_G_2E: DW $3800, $7FFF, $3C1F, $2C16, $180C, $6ADF, $49DF, $28DF, $001B, $7F90, $730F, $6A8E, $59AE, $514E, $7758, $0009
Beam_G_30: DW $3800, $7FFF, $4210, $2D6B, $18C6, $5AD6, $39CE, $18C6, $0000, $7BAE, $734D, $6B0C, $5A68, $5207, $7354, $0C63
Beam_G_32: DW $3800, $7FFF, $6318, $4210, $2529, $6B5A, $4A52, $294A, $0000, $7BAE, $776E, $6F2C, $6ACC, $628A, $7796, $18C6
Beam_G_34: DW $3800, $7FFF, $01FF, $0176, $00CC, $5B7F, $3AFF, $1A7F, $01DB, $7390, $6B4F, $5B0E, $424E, $3A0E, $7398, $0069

;"Metal" beam palette
Beam_M_36: DW $3800, $7FFF, $5AF8, $39F0, $1D09, $77DF, $6B7C, $5F19, $52B6, $778E, $6F4D, $670C, $5A48, $5207, $7BB8, $10A6
Beam_M_38: DW $3800, $7FFF, $021F, $0176, $00CC, $5B5F, $3B3F, $1ABF, $01DB, $7BB0, $736F, $6B2E, $5ACE, $528E, $7398, $00C9
Beam_M_3A: DW $3800, $7FFF, $431F, $2E16, $192C, $5B5F, $3B3F, $1ABF, $01DB, $7BB0, $736F, $6B2E, $5ACE, $528E, $7398, $0CC9
Beam_M_3C: DW $3800, $7FFF, $43FF, $2ED6, $198C, $6BFF, $4BFF, $2BFF, $037B, $7BD0, $778F, $7BAE, $6B0E, $66EE, $77D8, $0D29
Beam_M_3E: DW $3800, $7FFF, $6318, $4210, $2529, $6B5A, $5AD6, $4A52, $39CE, $7BAE, $776E, $6F2C, $6ACC, $628A, $7796, $18C6
Beam_M_40: DW $3800, $7FFF, $4210, $2D6B, $18C6, $5AD6, $4A52, $39CE, $294A, $7BAE, $734D, $6B0C, $5A68, $5207, $7354, $0C63
Beam_M_42: DW $3800, $7FFF, $6318, $4210, $2529, $6B5A, $5294, $39CE, $2108, $7BAE, $776E, $6F2C, $6ACC, $628A, $7796, $18C6
Beam_M_44: DW $3800, $7FFF, $0010, $000B, $0006, $001A, $0016, $0012, $000E, $738E, $6B0D, $5A8C, $41A8, $3947, $4A16, $0003
Beam_M_46: DW $3800, $7FFF, $0208, $0166, $00C3, $02CB, $0269, $0207, $01A5, $73AE, $6B4C, $5B0A, $4267, $3A04, $4B50, $0060
Beam_M_48: DW $3800, $7FFF, $6180, $4100, $24A0, $7E00, $71C0, $6580, $5940, $7B8D, $734A, $6EC8, $6A22, $61C0, $7EEA, $1860

;"Mixed" beam palette
Beam_X_4A: DW $3800, $7FFF, $03FF, $019F, $0016, $5BFF, $3ADF, $19DF, $00DB, $4390, $3F10, $3A8E, $39AE, $394E, $73D8, $0009
Beam_X_4C: DW $3800, $7FFF, $03FF, $03EC, $02C0, $5BFF, $3BF6, $1BEE, $0366, $43CD, $3F8A, $3B68, $3B02, $3AE0, $73D8, $0120
Beam_X_4E: DW $3800, $7FFF, $7FE0, $7D80, $5800, $7FF6, $7ECE, $7DC6, $6CC0, $7F80, $7B00, $7680, $71A0, $6B40, $7FD4, $2400
Beam_X_50: DW $3800, $7FFF, $02DF, $02D6, $02CC, $3ADF, $1AD6, $02CE, $01C6, $4390, $3F4D, $3B0A, $3AA5, $3A62, $6358, $0120
Beam_X_52: DW $3800, $7FFF, $7EC0, $5AC0, $32C0, $7ECE, $5AC6, $3AC0, $19C0, $7F80, $7340, $6700, $4EA0, $4260, $7F50, $0120
Beam_X_54: DW $3800, $7FFF, $7C16, $5816, $3016, $7DD6, $58D6, $3816, $180E, $7DCE, $71CD, $658C, $4D4A, $414A, $7ED4, $0009
Beam_X_56: DW $3800, $7FFF, $7FE0, $7EC0, $7D80, $7FEE, $7EC6, $7DC0, $38C0, $7F80, $7B00, $7680, $71A0, $6B40, $7FD4, $2400
Beam_X_58: DW $3800, $7FFF, $7FE0, $5A06, $300C, $7FF6, $7ED6, $69D6, $58D6, $7F82, $7B05, $7688, $71AC, $6D4E, $7FD4, $2409
Beam_X_5A: DW $3800, $7FFF, $03E0, $02C0, $0180, $5BF6, $3BEE, $1BE6, $0360, $73CD, $6B8A, $5B68, $4302, $3AE0, $73D4, $0120
Beam_X_5C: DW $3800, $7FFF, $599F, $58DA, $5816, $6ADF, $5DDB, $54D7, $4812, $7F90, $7B0F, $768E, $71AE, $6D4E, $7758, $2409
Beam_X_5E: DW $3800, $7FFF, $5BFF, $335A, $02D6, $7FFF, $3BFF, $03FF, $037B, $7BD0, $738F, $6F6E, $630E, $5EEE, $7FD8, $0129
Beam_X_60: DW $3800, $7FFF, $4812, $300C, $1806, $5816, $380E, $1806, $0000, $79CE, $71CD, $698C, $614A, $5948, $7214, $0000

;"Miscellaneous" beam palette
Beam_A_62: DW $3800, $7FFF, $7F10, $5976, $30C6, $5BFF, $6EF2, $6DDB, $6B8C, $7BAE, $734D, $6B0C, $628A, $5A48, $73D8, $1929
Beam_A_64: DW $3800, $7FFF, $0000, $0000, $0000, $7FFF, $7FFF, $0000, $0000, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $7FFF, $0000
Beam_A_66: DW $3800, $7FFF, $77FF, $4EB5, $2DAD, $77FF, $6B9C, $214A, $10C6, $6B9C, $635A, $5B18, $4252, $3A10, $73DE, $214A
Beam_A_68: DW $3800, $0000, $6600, $62AA, $6F52, $2C00, $7C60, $56A0, $6720, $146F, $14AF, $1CF1, $35B1, $3DF1, $1727, $6FB5
}
;---------------------------------------------------------------------------------------------------
;|x|									BANK $91		Samus palette routine (hijack)			 |x|
;---------------------------------------------------------------------------------------------------
{ ;---doesn't need freespace, uses space of code which is no longer necessary---

;Normal palette after fired charged shot
ORG $91D71E : JSR NeutralSetup
;Charge glow routine
ORG $91D799 : LDA $0B18 : BPL +
	JSL $91DEE6 : JSL InitialiseBeamShine : RTS
+ : JSL BeamShine : RTS
;4 bytes left

;Charging up beam
ORG $91D77F : JSR MoveToChargeSetup
;Screw Attack
ORG $91DA2E : JSR MoveToScrewAttackSetup
;Speed Booster
ORG $91DA94 : JSR MoveToSpeedBoosterSetup
;Shine (speed booster shine)
ORG $91DAF3 : JSR MoveToShineSetup
;Shine Spark
ORG $91DB58 : JSR MoveToShineSparkSetup
;Cancel speed booster
ORG $91DE7A : JSR NeutralSetup
ORG $91DE82 : JSR NeutralSetup
ORG $91DE8A : JSR NeutralSetup
;Load Samus palette
ORG $91DED0 : JSR NeutralSetup
ORG $91DED8 : JSR NeutralSetup
ORG $91DEE0 : JSR NeutralSetup
;Door transition
ORG $91DEFC : JSR TargetSetup
ORG $91DF04 : JSR TargetSetup
ORG $91DF0C : JSR TargetSetup


;Samus source colour loader, used for:
;(hurtflash; cinamatic grayscale; hyper beam glow)
ORG $91DD5B
	PHB
	LDY #$C180 : LDA #$001F : MVN $9B7E
	PLB : RTS

NeutralSetup:
	PHB : PHY : LDY #$C180 : LDA #$001F : MVN $9B7E		;apply palette to samus ([X] is source)
	LDA $0A76 : BNE +									;skip arm cannon palette overwrite, if hyper beam is active
	JSR NeutralCannonPaletteOffsetFinder
	LDA.l !BankCannonPalette/$10000*$10000,x : STA.w !TargetPalette0*2+$C180
	LDA.l !BankCannonPalette/$10000*$10000+2,x : STA.w !TargetPalette1*2+$C180
	LDA.l !BankCannonPalette/$10000*$10000+4,x : STA.w !TargetPalette2*2+$C180
	LDA.l !BankCannonPalette/$10000*$10000+6,x : STA.w !TargetPalette3*2+$C180
+ : PLY : PLB : CLC : RTS
	
TargetSetup:									;target palettes are used for door transitions
	PHB : LDY #$C380 : LDA #$001F : MVN $9B7E	;apply to samus's target palette ([X] is source)
	LDA $0A76 : BNE +							;skip arm cannon palette overwrite, if hyper beam is active
	JSR NeutralCannonPaletteOffsetFinder
	LDA.l !BankCannonPalette/$10000*$10000,x : STA.w !TargetPalette0*2+$C380
	LDA.l !BankCannonPalette/$10000*$10000+2,x : STA.w !TargetPalette1*2+$C380
	LDA.l !BankCannonPalette/$10000*$10000+4,x : STA.w !TargetPalette2*2+$C380
	LDA.l !BankCannonPalette/$10000*$10000+6,x : STA.w !TargetPalette3*2+$C380
+ : PLB : CLC : RTS

;remaining freespace can be used for hijacks, now.
MoveToChargeSetup:
	JSR $DD5B
	JSL	ChargeSetup : RTS

MoveToSpeedBoosterSetup:
	JSR $DD5B
	LDA $0A76 : BNE + : JSL	SpeedBoosterSetup	;skip arm cannon palette overwrite, if hyper beam is active
+ : RTS											;only "charge" doesn't have it, because "charge" can never be triggered with hyper beam equipped.

MoveToShineSetup:
	JSR $DD5B
	LDA $0A76 : BNE + : JSL	ShineSetup
+ : RTS

MoveToShineSparkSetup:
	JSR $DD5B
	LDA $0A76 : BNE + : JSL	ShineSparkSetup
+ : RTS

MoveToScrewAttackSetup:
	JSR $DD5B
	LDA $0A76 : BNE + : JSL	ScrewAttack
+ : RTS

NeutralCannonPaletteOffsetFinder:
	LDA !CannonPalette : CMP #$0002 : BEQ +			;check if "Beam Color" is active
	CMP #$000C : BEQ ++								;check if "PB Beam Color" is active
- : TAX : LDA.l PalettePointer,x : TAX : RTS		;save cannon color bank
+ : LDA $09A6 : AND #$000F : ASL : TAX : LDA.l BeamCannonMFPointer,x : BRA -
++ : LDA $09A6 : AND #$000F : ASL : TAX : LDA.l BeamCannonPBPointer,x : BRA -

PADBYTE $FF : PAD $91DE53		;delete original "Load Samus source/target colours"
}
;---------------------------------------------------------------------------------------------------
;|x|									BANK $97		Compressed images						 |x|
;---------------------------------------------------------------------------------------------------
{ ;---doesn't need freespace, deleted compressed data of game option menu "controller setting japanese, special setting english and japanese"---
;delete compressed data from game option menu "controller setting japanese, special setting english/japanese"
ORG $9791C4 : PADBYTE $FF : PAD $9796F4
ORG $9791C4
{;Special setting english (changed with cannon color options)
SpecialSettingImage:
	DB $E8, $4B, $0F, $00
;"special setting mode"
;top half
	DB $0C, $2B, $00, $0D, $00, $0E, $00, $0C, $00, $22, $00, $0A, $00, $25
	DB $C4, $10
	DB $00, $0E
	DB $44, $00, $2C
	DB $02, $22, $00, $27
	DB $C2, $16
	DB $02, $0F, $00, $26
	DB $22, $00
	DB $02, $0D, $00, $0E
	DB $58, $00, $0F

;bottom half
	DB $0C, $3B, $00, $38, $00, $1E, $00, $1C, $00, $11, $00, $1A, $00, $35
	DB $C4, $10
	DB $00, $1E
	DB $46, $00, $11
	DB $02, $37, $00, $30
	DB $C2, $10
	DB $06, $36, $00, $10, $00, $1D, $00, $1E
	DB $E9, $12, $00, $0F
	
;"cannon color setting"
;top half
	DB $02, $0C, $00, $0A
	DB $44, $00, $27
	DB $02, $00, $00, $27
	DB $C2, $20
	DB $08, $0C, $00, $00, $00, $25, $00, $00, $00, $0D
	DB $C2, $20
	DB $02, $2B, $00, $0E
	DB $44, $00, $2C
	DB $84, $64, $00
	DB $58, $00, $0F

;bottom half
	DB $02, $1C, $00, $1A
	DB $44, $00, $37
	DB $02, $10, $00, $37
	DB $C2, $20
	DB $08, $1C, $00, $10, $00, $35, $00, $10, $00, $3A
	DB $C2, $20
	DB $02, $3B, $00, $1E
	DB $46, $00, $11
	DB $82, $A6, $00
	DB $E8, $58, $00, $0F

;"apply color to beams  <checkbox>"
;top half
	DB $00, $0A
	DB $44, $00, $0D
	DB $02, $25, $00, $41
	DB $CE, $BE
	DB $02, $2C, $00, $00
	DB $C2, $20
	DB $08, $0B, $00, $0E, $00, $0A, $00, $26, $00, $2B
	DB $C4, $40
	DB $04, $B4, $06, $B5, $06, $0F
	DB $4E, $00, $0F

;bottom half
	DB $00, $1A
	DB $44, $00, $38
	DB $02, $35, $00, $11
	DB $CE, $BE
	DB $02, $11, $00, $10
	DB $C2, $20
	DB $08, $1B, $00, $1E, $00, $1A, $00, $36, $00, $3B
	DB $C4, $40
	DB $04, $B6, $06, $B7, $06, $0F
	DB $E8, $8E, $00, $0F

;"icon cancel" with options
;top half
	DB $02, $22, $00, $0C
	DB $22, $00
	DB $00, $27
	DB $C2, $0A
	DB $02, $0C, $00, $0A
	DB $84, $65, $00
	DB $02, $0E, $00, $25
	DB $44, $00, $0F
	;"auto"
	DB $07, $0A, $04, $2D, $04, $2C, $04, $00, $04
	DB $45, $0F, $00
	;"manuel"
	DB $00, $26
	DB $C4, $1E
	DB $00, $2D
	DB $83, $55, $00
	DB $4C, $00, $0F

;bottom half
	DB $06, $11, $00, $1C, $00, $10, $00, $37
	DB $C2, $0A
	DB $02, $1C, $00, $1A
	DB $C2, $08
	DB $04, $1C, $00, $1E, $00, $35
	DB $44, $00, $0F
	;"auto"
	DB $07, $1A, $04, $10, $04, $11, $04, $10, $04
	DB $45, $0F, $00
	;"manuel"
	DB $00, $36
	DB $C4, $1E
	DB $00, $10
	DB $83, $95, $00
	DB $E8, $8C, $00, $0F

;"moon walk" with options
	DB $00, $26
	DB $24, $00
	DB $83, $8C, $03
	DB $00, $2F
	DB $84, $55, $00
	DB $00, $24
	DB $4A, $00, $0F
	DB $03, $00, $04, $27, $04
	DB $4A, $0F, $00
	DB $22, $00
	DB $43, $0E, $00
	DB $4D, $0F, $00
	DB $00, $36
	DB $44, $00, $10
	DB $83, $CC, $03
	DB $00, $3F
	DB $84, $95, $00
	DB $00, $34
	DB $4A, $00, $0F
	DB $03, $10, $04, $37, $04
	DB $4B, $0F, $00
	DB $00, $10
	DB $44, $00, $1F
	DB $4B, $0F, $00
	DB $04, $47, $00, $2B, $00, $21
	DB $22, $00
	DB $00, $2C
	DB $C2, $0C
	DB $00, $21
	DB $22, $00
	DB $0A, $25, $00, $0D, $00, $45, $00, $B4, $00, $B5, $00, $48
	DB $E8, $24, $00, $0F
	DB $04, $57, $00, $3B, $00, $31
	DB $C2, $58
	DB $00, $11
	DB $C2, $0C
	DB $C3, $08
	DB $0A, $35, $00, $1D, $00, $55, $00, $C4, $00, $C5, $00, $58
	DB $E8, $AA, $00, $0F

;control
	;D pad
	DB $02, $B2, $00, $B3
	DB $CC, $40
	;D pad or A
	DB $82, $1A, $05
	DB $C4, $10
	DB $03, $90, $00, $90, $40
	DB $CB, $40
	;B
	DB $02, $91, $00, $92
	DB $D4, $40

	;D pad
	DB $02, $C2, $00, $C3
	DB $CC, $40
	;D pad or A
	DB $83, $5A, $05
	DB $02, $78, $00, $7B
	DB $43, $00, $A0
	DB $00, $40
	DB $CB, $40
	;B
	DB $02, $A1, $00, $A2
	DB $D0, $40

	;"cursor"
	DB $0A, $6C, $00, $7E, $00, $7B, $00, $7C, $00, $78, $00, $7B
	DB $C8, $40
	;"select"
	DB $04, $7C, $00, $6E, $00, $75
	DB $C2, $04
	DB $02, $6C, $00, $7D
	DB $CA, $40
	;"exit"
	DB $06, $6E, $00, $81, $00, $72, $00, $7D
	
	DB $E9, $48, $00, $0F
	DB $FF
}
{;Cannon color setting
CannonColorSettingImage:
	DB $E8, $4B, $0F, $00
	;"cannon color setting"
;top half
	DB $02, $0C, $00, $0A
	DB $44, $00, $27
	DB $02, $00, $00, $27
	DB $C2, $20
	DB $08, $0C, $00, $00, $00, $25, $00, $00, $00, $0D
	DB $C2, $20
	DB $02, $2B, $00, $0E
	DB $44, $00, $2C
	DB $04, $22, $00, $27, $00, $0C
	DB $58, $00, $0F

;bottom half
	DB $02, $1C, $00, $1A
	DB $44, $00, $37
	DB $02, $10, $00, $37
	DB $C2, $20
	DB $08, $1C, $00, $10, $00, $35, $00, $10, $00, $3A
	DB $C2, $20
	DB $02, $3B, $00, $1E
	DB $46, $00, $11
	DB $02, $37, $00, $30
	DB $E8, $EC, $00, $0F
	
	;"group"
	DB $08, $70, $00, $7B, $00, $78, $00, $7E, $00, $79
	DB $F8, $2A, $40

	;arrows
	DB $01, $B0, $02
	DB $E8, $1D, $0F, $00
	DB $01, $B2, $02
	DB $5D, $0F, $00
	
	DB $01, $B1, $02
	DB $E8, $1D, $0F, $00
	DB $01, $B3, $02
	DB $E8, $A9, $0F, $00

	;"color"
	DB $04, $6C, $00, $78, $00, $75
	DB $C2, $04
	DB $00, $7B
	
	;arrows
	DB $F0, $8C, $A9, $01
	DB $E8, $DB, $0F, $00
	
	;cannon
	DB $01, $D6, $0E
	DB $51, $0F, $00
	DB $07, $BC, $0E, $BD, $0E, $BE, $0E, $BF, $0E
	DB $E8, $21, $0F, $00
	DB $10, $C2, $0E, $C3, $0E, $C4, $0E, $C5, $0E, $C6, $0E, $C7, $0E, $C8, $0E, $C9, $0E, $CA
	DB $44, $0E, $CB
	DB $07, $CC, $0E, $CD, $0E, $CE, $0E, $CF, $0E
	DB $E8, $21, $0F, $00
	DB $06, $D2, $0E, $D3, $0E, $D4, $0E, $D5
	DB $46, $0E, $D9
	DB $02, $DA, $0E, $DB
	DB $46, $0E, $DC
	DB $05, $DD, $0E, $DE, $0E, $DF, $0E
	DB $E8, $21, $0F, $00
	DB $10, $C2, $8E, $C3, $8E, $C4, $8E, $C5, $8E, $C6, $8E, $C7, $8E, $C8, $8E, $C9, $8E, $CA
	DB $44, $8E, $CB
	DB $07, $CC, $8E, $CD, $8E, $CE, $8E, $CF, $8E
	DB $E8, $23, $0F, $00
	DB $01, $D6, $8E
	DB $51, $0F, $00
	DB $07, $BC, $8E, $BD, $8E, $BE, $8E, $BF, $8E
	DB $E8, $A1, $0F, $00
	
	;D pad
	DB $02, $B6, $00, $B7
	DB $D2, $40
	;A or B
	DB $03, $90, $00, $90, $40
	DB $C3, $40
	DB $02, $91, $00, $92
	DB $DE, $40

	;D pad
	DB $02, $C6, $00, $C7
	DB $D2, $40
	;A or B
	DB $42, $A0, $00
	DB $07, $40, $78, $00, $7B, $00, $A1, $00, $A2
	DB $DA, $40

	;"cursor"
	DB $0A, $6C, $00, $7E, $00, $7B, $00, $7C, $00, $78, $00, $7B
	DB $D0, $C0
	;"exit"
	DB $06, $6E, $00, $81, $00, $72, $00, $7D
	
	DB $E9, $48, $00, $0F
	DB $FF
}
}
;---------------------------------------------------------------------------------------------------
;|x|									BANK $9B		Death sequence							 |x|
;---------------------------------------------------------------------------------------------------
{ ;---doesn't need freespace, efficently compacted code of original code---
ORG $9BB4B6 : PADBYTE $FF : PAD $9BB6D8
ORG $9BB48F	: JSR DeathSequencePaletteSet
ORG $9BB7B3	: JSR DeathSequencePaletteSet
ORG $9BB4B6
;First frame palette set
	PHP : REP #$30
	LDY $0A74 : LDA DeathSequencePointer,y : TAX : LDA $0000,x : TAX	;set palette for current samus palette to [X]
	JSR WriteSamusPalette
	LDX #$A120			;suitless samus palette
	JSR WriteSuitlessSamusPalette
	LDY #$0008 : JSR $B6D8
	LDA $B823 : AND #$00FF : STA $0DE2
	STZ $0DE4 : STZ $0DE6
	JSR $B758			;go to death sequence subroutine
	PLP : RTS

DeathSequencePaletteSet:
	PHP : REP #$30
	LDY $0A74 : LDA DeathSequencePointer,y : STA $14	;current suit
	LDA $B80F,x : STA $16	;suitless samus palette pointer from $B80F
	TXA : CLC : ADC $14 : TAX : LDA $0000,x : TAX
	JSR WriteSamusPalette
	LDX $16					;load suitless samus palette pointer
	JSR WriteSuitlessSamusPalette
	PLP : RTS

;Setting samus palette
WriteSamusPalette:
	PHB
	LDY #$C180 : LDA #$001F : MVN $9B7E
	PLB
	LDA $0A76 : BNE + : JSL DeathSetup				;skip arm cannon palette overwrite during death sequence, if hyper beam is active
+ : RTS
	
;Setting suitless samus palette
WriteSuitlessSamusPalette:
	PHB
	LDY #$C1E0 : LDA #$001F : MVN $9B7E
	PLB : RTS

DeathSequencePointer:
	DW $B7D3, $B7E7, $B7FB
}
